#include <stdio.h>

FILE *f = fopen("poze.in", "r");
FILE *g = fopen("poze.out", "w");

long const nmax = 310;
long const hsize = 999983;

long t, n, m, k;
long a[nmax][nmax];
long hash[hsize], ver[nmax][nmax];
long zec[nmax], hec[nmax];

void citeste();
int egal(long x1, long y1, long x2, long y2, long k);
int gencod(long x);
int suntk(long x);
long min(long a, long b);
long detmax();

int main() {
	citeste();
	fclose(f);
	fclose(g);
	return 0;
}

void citeste() {
	long i, j, l;

	zec[0] = 1;
	hec[0] = 1;
	for(i=1; i<nmax; i++) {
		zec[i] = (zec[i-1] * 19) % hsize;
		hec[i] = (hec[i-1] * 23) % hsize;
	}
	
	fscanf(f, "%ld", &t);
	for(l=1; l<=t; l++) {
		fscanf(f, "%ld%ld%ld", &n, &m, &k);
		for(i=1; i<=n; i++)
			for(j=1; j<=m; j++)
				fscanf(f, "%ld", &(a[i][j]));
		fprintf(g, "%d\n", detmax());
	}
}

int egal(long x1, long y1, long x2, long y2, long k) {
	long i, j;

	for(i=0; i<k; i++)
		for(j=0; j<k; j++)
			if( a[x1+i][y1+j] != a[x2+i][y2+j] )
				return 0;
	return 1;
}

int gencod(long x) {
	long i, j, p, q;

	for(i=1; i<=n-x+1; i++) {
		for(j=1; j<=m-x+1; j++) {
			ver[i][j] = 0;
			for(p=1; p<=x; p++)
				for(q=1; q<=x; q++) {
					ver[i][j] += (long)(((long long)a[i+p-1][j+q-1] * zec[p] * hec[q]) % hsize);
					ver[i][j] %= hsize;
				}
			hash[ver[i][j]]++;
		}
	}
}

int suntk(long x) {
	long i, j, sw;

	sw = 0;
	gencod(x);
	for(i=1; i<=n-x+1; i++)
		for(j=1; j<=m-x+1; j++) {
			if( hash[ver[i][j]] >= k ) sw = 1;
			hash[ver[i][j]] = 0;
		}
	
	return sw;
}

long min(long a, long b) {
	if( a <= b ) return a;
	return b;
}

long detmax() {
	long i;
	long lim1, lim2;
	long med;

	lim1 = 0;		 //se poate
	lim2 = min(n, m); //nu se poate
	while(lim2 - lim1 > 1) {
		med = (lim1 + lim2) / 2;
		if( suntk(med) == 1 ) lim1 = med;
		else lim2 = med;
	}
	return lim1;
}

