{uses dos;}
const MaxP=310;
      Mlr=1000000000;
var a,h1,{h2,}hl:array[0..MaxP,0..MaxP] of longint;
x,y,rez,num:array[0..MaxP*MaxP] of longint;
prim:array[0..MaxP] of qword;
{timp,}base,mod1,mod2,rep,tst,l,m,n:longint;

{function time:longint;
var ora,min,sec,ss:word;
begin
gettime(ora,min,sec,ss);
time:=longint(min)*60000+longint(sec)*1000+longint(ss)*10;
end;}

function eprim(k,max:longint):boolean;
var i:longint;
begin
eprim:=true;
if not odd(k) then exit(false);
for i:=1 to max div 2 do
 if k mod (2*i+1)=0 then exit(false);
end;

procedure precalc;
var i,k:longint;
begin
for i:=1 to MaxP do
 begin
 k:=random(Mlr)+Mlr;
 while not eprim(k,4562) do k:=random(Mlr)+Mlr;
 prim[i]:=k;
 end;
mod1:=random(Mlr)+Mlr;
while not eprim(mod1, trunc(sqrt(mod1))) do mod1:=random(Mlr)+Mlr;
mod2:=random(Mlr)+Mlr;
while not eprim(mod2, trunc(sqrt(mod2))) do mod2:=random(Mlr)+Mlr;
base:=random(Mlr)+Mlr;
while not eprim(base, trunc(sqrt(base))) do base:=random(Mlr)+Mlr;
end;

procedure swap(i,j:longint);
var k:longint;
begin
k:=num[i]; num[i]:=num[j]; num[j]:=k;
k:=x[i];   x[i]:=x[j];     x[j]:=k;
k:=y[i];   y[i]:=y[j];     y[j]:=k;
end;

procedure update(k,nr:longint);
begin
while (2*k<=nr) and ((num[2*k]>num[k]) or (num[2*k+1]>num[k])) do
 if num[2*k]>num[2*k+1] then
                        begin
                        swap(k,2*k); k:=2*k;
                        end
                        else
                        begin
                        swap(k,2*k+1); k:=2*k+1;
                        end;
end;

procedure hsort(nr:longint);
var i,k:longint;
begin
num[nr+1]:=-1;
for i:=2 to nr do
 begin
 k:=i;
 while (k>1) and (num[k div 2]<num[k]) do
  begin
  swap(k, k div 2); k:=k div 2;
  end;
 end;
for i:=nr downto 1 do
 begin
 rez[i]:=num[1]; num[1]:=-1;
 swap(1,nr); dec(nr);
 update(1,nr);
 end;
end;

function check(x1,y1,x2,y2,lung:longint):boolean;
var i,j:longint;
begin
for i:=1 to lung do
 for j:=1 to lung do
 if a[x1+i-1, y1+j-1]<>a[x2+i-1, y2+j-1] then exit(false);
check:=true;
end;

function calch(lung:longint):boolean;
var max,i,j,k,nr,nrh:longint;
begin
if lung=0 then exit(true);
calch:=false; nrh:=0;
for i:=1 to n do
 for j:=1 to m-lung+1 do
 begin
 nr:=a[i,j]*prim[1] mod mod1;
 for k:=1 to lung-1 do
  nr:=(nr*prim[MaxP-k]+a[i,j+k]*prim[k+1]) mod mod1;
 hl[i,j]:=nr;
 end;
for i:=1 to n-lung+1 do
 for j:=1 to m-lung+1 do
  begin
  nr:=hl[i,j]*prim[1] mod mod1;
  for k:=1 to lung-1 do
   nr:=(nr*prim[MaxP-k]+hl[i+k,j]*prim[k+1]) mod mod1;
  h1[i,j]:=nr;
  end;
for i:=1 to n-lung+1 do
 for j:=1 to m-lung+1 do
 begin
 inc(nrh); num[nrh]:=h1[i,j];
 x[nrh]:=i; y[nrh]:=j;
 end;
hsort(nrh); max:=1;
i:=1; rez[nrh+1]:=-1;
while (i<=nrh) do
 begin
 j:=i;
 while (rez[i]=rez[j+1]) do inc(j);
 if (rep>2) or ((rep=2) and (j>i) and check(x[i],y[i],x[j],y[j],lung)) then
 if j-i+1>max then max:=j-i+1;
 i:=j+1;
 end;
if max>=rep then calch:=true;
end;

procedure solve;
var mij,p,u,i,j:longint;
begin
readln(n,m,rep);
for i:=1 to n do
 for j:=1 to m do
 begin
 read(a[i,j]);
 inc(a[i,j]);
 end;
p:=0; u:=n;
if m<n then u:=m;
while (p<u) do
 begin
 mij:=(p+u) div 2+1;
 if calch(mij) then p:=mij
               else u:=mij-1;
 end;
writeln(u);
end;
 
begin
{timp:=time;}
randomize;
assign(input,'poze.in'); reset(input);
assign(output,'poze.out'); rewrite(output);
precalc;
readln(tst);
for l:=1 to tst do
 solve;
{writeln(stderr,'A durat ',(time-timp)/1000:3:3,' secunde.');}
close(input); close(output);
end.
