#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <vector>
#include <algorithm>
using namespace std;

#define FOR(i, a, b) for (i = (a); i <= (b); i ++)
#define REP(i, n)    for (i =   0; i <  (n); i ++)
#define FORI(i, x)   for (i = (x).begin(); i != (x).end(); i ++)
#define mp           make_pair
#define pb           push_back

#define NMAX 305

int a[NMAX][NMAX], T, M, N, K, i, j, k, sz, nr;
int o[NMAX][NMAX];
int f[32768];

struct entry {
    int q1, q2, x, lab;
} v[NMAX * NMAX];

int cmp(struct entry a, struct entry b)
{
    if (a.q1 == b.q1)
        return a.q2 < b.q2 ? 1 : 0;
    else
        return a.q1 < b.q1 ? 1 : 0;
}

int next(void)
{
    register int i, j, nr_ap, ok;
    if (2 * sz > M || 2 * sz > N) return 0;
    nr = 0;
    REP(i, M - 2 * sz + 1)
        REP(j, N - 2 * sz + 1)
        {
            v[nr].q1 = o[i][j] * 30001 + o[i][j + sz], v[nr].q2 = o[i + sz][j] * 30001 + o[i + sz][j + sz];
            v[nr].x = i * NMAX + j;
            ++ nr;
        }
    sort(v, v + nr, cmp);

    nr_ap = 1, ok = 0;
    v[0].lab = 0;

    FOR(i, 1, nr - 1)
    {
        if (v[i].q1 == v[i - 1].q1 && v[i].q2 == v[i - 1].q2)
        {
            v[i].lab = v[i - 1].lab;
            if ((++ nr_ap) >= K) ok = 1;
        }
        else
        {
            v[i].lab = 1 + v[i - 1].lab;
            nr_ap = 1;
        }
    }
    
    if (!ok) return 0;

    //ok -> updatez
    REP(i, nr)
        o[v[i].x / NMAX][v[i].x % NMAX] = v[i].lab;
    sz <<= 1;
    return 1;
}

int works(int x)
{
    register int i, j, nr_ap;
    nr = 0;
    REP(i, M - x + 1)
        REP(j, N - x + 1)
        {
            v[nr].q1 = o[i][j] * 30001 + o[i][j + x - sz], v[nr].q2 = o[i + x - sz][j] * 30001 + o[i + x - sz][j + x - sz];
            ++ nr;
        }
    sort(v, v + nr, cmp);

    nr_ap = 1;
    FOR(i, 1, nr - 1)
    {
        if (v[i].q1 == v[i - 1].q1 && v[i].q2 == v[i - 1].q2)
        {
            if ((++ nr_ap) >= K) return 1;
        }
        else
            nr_ap = 1;
    }

    return 0;
}

void baga(void)
{
    //stage 1:
    memset(f, 0, sizeof(f));
    REP(i, M)
        REP(j, N)
            ++ f[o[i][j] = a[i][j]];
    sz = 1;

    //verific daca solutia e 0
    int bad = 1;
    FOR(i, 0, 30000)
        if (f[i] >= K) { bad = 0; break; }
    if (bad) { printf("0\n"); return; }

    //maresc sz
    while (next());

    //stage 2:
    int l, r, m;
    l = sz, r = 1 + (M < N ? M : N);
    while (l + 1 < r)
    {
        m = (l + r) / 2;
        if (works(m))
            l = m;
        else
            r = m;
    }

    printf("%d\n", l);
}

void gen(void)
{
    freopen("poze.in", "w", stdout);
    
    int i, j, k;
    M = N = 300, K = 5, T = 5;
    printf("%d\n", T);
    REP(k, T)
    {
        printf("%d %d %d\n", M, N, K);
        REP(i, M)
        {
            REP(j, N)
            {
                printf("%d ", rand() % (k + 1));
                /*
                if (i == M - 1 && j == N - 1)
                    printf("1 ");
                else
                    printf("0 ");
                */
            }
            printf("\n");
        }
    }
}

int main(void)
{
//gen();
//return 0;

    freopen("poze.in", "r", stdin);
    freopen("poze.out", "w", stdout);
    for (scanf("%d", &T); T; T --)
    {
        scanf("%d %d %d", &M, &N, &K);
        REP(i, M)
            REP(j, N)
                scanf("%d", &(a[i][j]));
        baga();
    }

    return 0;
}
