#include <stdio.h>
#define nmax 305
#define prim 45007
#define vmax 30000

FILE *fin,*fout;

long t,n,m,k,a[nmax][nmax],f[nmax][nmax],p[nmax*nmax];
long h[prim+1],uz[nmax][nmax],*x[prim+1],*y[prim+1];

long i,j;
long identic(long l,long x1,long y1,long x2,long y2)
{
 for (i=0;i<l;i++)
 for (j=0;j<l;j++) if (a[x1+i][y1+j]!=a[x2+i][y2+j]) return 0;
 return 1;
}
void calc_func(long l) //calculez functia pentru fiecare patrat de lungime l
{
 long i,j,k,r;
 for (i=n-l;i>=0;i--)
 {
  //calculez f[i][m-l]
  f[i][m-l]=0;
  if (i==n-l)
  {
   for (j=0;j<l;j++) //coloana
   for (k=0;k<l;k++) //linia
   {
    f[i][m-l]+=p[k+l*j]*a[i+k][m-l+j] % prim;
    f[i][m-l]%=prim;
   }
  }
  else
  {
   r=f[i+1][m-l];
   for (j=0;j<l;j++)
   {
    r-= ( a[i+l][m-l+j]*p[j*l+l-1]%prim ) ;
    while (r<0) r+=prim;
   }
   r=(r*p[1])%prim;
   for (j=0;j<l;j++) r= ( r + p[j*l]*a[i][m-l+j] ) % prim;
   f[i][m-l]=r;
  }
  for (j=m-l-1;j>=0;j--)
  {
   //calculez f[i][j]
   r=f[i][j+1];
   for (k=0;k<l;k++)
   {
    r-= ( p[l*(l-1)+k]*a[i+k][j+l]%prim ) ;
    while (r<0) r+=prim;
   }
   r=(r*p[l])%prim;
   for (k=0;k<l;k++) r = ( r + p[k]*a[i+k][j] )%prim;
   f[i][j]=r;   
  }
 }
}
long suntk(long l) //vad daca am cel putin k patrate identice de lungime l
{
 long i,j,o,nc;
 if (l==0) return 1;
 calc_func(l);
 for (i=0;i+l-1<n;i++)
 for (j=0;j+l-1<m;j++) h[f[i][j]]++;

 for (i=0;i<prim;i++)
 {
  x[i]=(long*)calloc(h[i],sizeof(long));
  y[i]=(long*)calloc(h[i],sizeof(long));
  h[i]=0;
 }

 for (i=0;i+l-1<n;i++)
 for (j=0;j+l-1<m;j++)
 {
  x[f[i][j]] [h[ f[i][j] ]  ]=i;
  y[f[i][j]] [h[ f[i][j] ]++]=j;
 }

 for (i=0;i<n;i++)
 for (j=0;j<m;j++) uz[i][j]=0;
 
 for (i=0;i<prim;i++) if (h[i]>=k)
 {
  for (j=0;j<h[i];j++) if (!uz[x[i][j]][y[i][j]])
  {
   uz[x[i][j]][y[i][j]]=1;
   nc=1;
   for (o=j+1;o<h[i];o++) if (identic(l,x[i][j],y[i][j],x[i][o],y[i][o]))
   {
    uz[x[i][o]][y[i][o]]=1;
    nc++;
   }
   if (nc>=k) return 1;
  }
 }
 return 0;
}
int main()
{
 long i,j,l1,l2,max=30001;
 fin=fopen("poze.in","rt");
 fout=fopen("poze.out","wt");
 
 fscanf(fin,"%ld",&t);

 while (t--)
 {
  fscanf(fin,"%ld %ld %ld",&n,&m,&k);
  for (i=0;i<n;i++)
  for (j=0;j<m;j++) fscanf(fin,"%ld",&a[i][j]);
  
  p[0]=1;
  for (i=1;i<=n*n && i<=m*m;i++)
  {
   p[i]=p[i-1]*max%prim;
  }

  l1=0;
  l2=n;
  if (m<n) l2=m;

  while (l2-l1>1)
  {
   if (suntk((l1+l2)/2))
   {
    l1=(l1+l2)/2;
   }
   else
   {
    l2=(l1+l2)/2;
   }
  }
  while (suntk(l1)) l1++;

  fprintf(fout,"%ld\n",l1-1);
 }
 fclose(fin);
 fclose(fout);
 return 0;
}

