#include <stdio.h>
#include <string.h>

#define MAX_N 150010

#define FIN  "peg.in"
#define FOUT "peg.out"

int T, N;
int v[4], nv;
char S[MAX_N];

int solve()
{
	int i, j, ok;
	for (i = 0; i < N && S[i] != '1'; ++i);
	for (; i+2 < N && S[i] == '1' && S[i+1] == '1' && S[i+2] == '0'; i += 2) {
		S[i] = '0';
		S[i+1] = '0';
		S[i+2] = '1';
	}
	for (i = N-1; i >= 0 && S[i] != '1'; --i);
	for (; i > 1 && S[i] == '1' && S[i-1] == '1' && S[i-2] == '0'; i -= 2) {
		S[i] = '0';
		S[i-1] = '0';
		S[i-2] = '1';
	}
	for (nv = ok = i = 0; i < N; i += j) {
		if (S[i] == '1') {
			for (j = 0; i+j < N && S[i+j] == '1'; ++j);
			v[nv++] = j;
			if (nv == 3)
				break;
		} else {
			j = 1;
			if (i > 0 && i+1 < N && S[i-1] == '1' && S[i] == '0' &&
					S[i+1] == '1')
				ok = 1;
		}
	}
	switch(nv) {
		case 0:
			return 0;
		case 1:
			return (v[0] == 1 || (v[0] == 2 && N > 2));
		case 2:
			if (!ok)
				return 0;
			if (v[0] == 1 && v[1] % 2 == 0)
				return 1;
			if (v[0] % 2 == 0 && v[1] == 1)
				return 1;
			if (v[0] % 2 == 1 && v[1] == 4)
				return 1;
			if (v[0] == 4 && v[1] % 2 == 1)
				return 1;
			return 0;
		default:
			return 0;
	}	
}

int main()
{
	freopen(FIN, "r", stdin);
	freopen(FOUT, "w", stdout);

	for (scanf("%d\n", &T); T--; ) {
		fgets(S, MAX_N, stdin);
		N = strlen(S)-1;
		printf("%d\n", solve());
	}
	return 0;
}
