#include <stdio.h>
#include <string.h>

#define MAXN 264

void read(void);
void dfs(int nod);
int go_up(int a, int b);
void baga(int a, int c);

int N, M, K, V[MAXN][MAXN], nrv[MAXN], seen[MAXN], fii[MAXN][MAXN], nrf[MAXN],
	nr[MAXN], T[MAXN], cupl[MAXN][MAXN], nrc[MAXN], tt[MAXN];

int main(void)
{
	int i;

	freopen("import.in", "r", stdin);
    freopen("import.out", "w", stdout);

    memset(V, -1, sizeof(V));
    memset(fii, -1, sizeof(fii));
    memset(cupl, -1, sizeof(cupl));
    T[0] = -1;

    read();

    for (i = 0; i < N; i++)
    	printf("%d ", nr[i]);

    return 0;
}

void read(void)
{
	int i, p, q, a, b, c, d, *k, pr;

	scanf("%d %d %d", &N, &M, &K);

    for (i = 0; i < N - 1; i++)
    {
    	scanf("%d %d", &p, &q), p--, q--;
        V[p][nrv[p]++] = q, V[q][nrv[q]++] = p;
    }

    dfs(0);

    for (i = 0; i < M; i++)
    {
    	scanf("%d %d %d %d", &a, &b, &c, &d), a--, b--;
        pr = go_up(a, b);
        memset(tt, 0, sizeof(tt));

        if (!d)
        {
        	if (pr >= c)
            	continue;
			c -= pr;
            baga(a, c);
        }
        else
        {
        	if (pr < c)
            	continue;
			c = -(pr - (c - 1));
            baga(b, c);
        }

        cupl[a][nrc[a]++] = b, cupl[b][nrc[b]++] = a;
    }
}

void dfs(int nod)
{
	int *k;

	seen[nod] = 1;

    for (k = V[nod]; *k != -1; k++)
    	if (!seen[*k])
        {
        	if (nod != 1 || (nod == 1 && *k < K))
	        	fii[nod][nrf[nod]++] = *k;
			T[*k] = nod;
            dfs(*k);
        }
}

int go_up(int a, int b)
{
	int nod, sum = 0;

    for (nod = a; nod != -1; nod = T[nod])
    	sum += nr[nod];

	for (nod = b; nod != -1; nod = T[nod])
    	sum += nr[nod];
	sum -= nr[0];

	return sum;
}

void baga(int a, int c)
{
	int *k;

    tt[a] = 1;
	nr[a] += c;
    for (k = fii[a]; *k != -1; k++)
    	nr[*k] -= c;

	for (k = cupl[a]; *k != -1; k++)
    	if (!tt[*k])
		   	baga(*k, -c);
}
