#include <stdio.h>

#define nm 100100
#define prec 0.001

void sort(int, int);
int part(int, int);

int n,x[nm],y1[nm],y2[nm],tmp;

int main()
{
    int i,j,ok,a1,b1,a2,b2;
    double first,middle,last,minx,miny,maxx,maxy,em,en;

    freopen("oypara.in","r",stdin);
    freopen("oypara.out","w",stdout);

    scanf("%d",&n);
    for (i=1; i<=n; i++)
    {
        scanf("%d%d%d",&x[i],&y1[i],&y2[i]);
        if (y1[i]>y2[i])
        {
            tmp=y1[i];
            y1[i]=y2[i];
            y2[i]=tmp;
        }
    }
    sort(1,n);

    first=y1[1];
    last=y2[1];
    while(first<last)
    {
        middle=(first+last)/2;
        minx=y1[2]-middle;
        maxx=y2[2]-middle;
        miny=maxy=x[2]-x[1];
        for (i=3,ok=1; i<=n && ok; i++)
        {
            if ((long double)minx*(x[i]-x[1])<(long double)(y1[i]-middle)*miny)
            {
                minx=y1[i]-middle;
                miny=x[i]-x[1];
            }
            if ((long double)maxx*(x[i]-x[1])>(long double)(y2[i]-middle)*maxy)
            {
                maxx=y2[i]-middle;
                maxy=x[i]-x[1];
            }
            if ((long double)minx*(x[i]-x[1])>(long double)(y2[i]-middle)*miny)
                ok=0;
        }
        if ((long double)minx*maxy<=(long double)maxx*miny)
            break;
        if (!ok)
            first=middle+prec;
        else
            last=middle-prec;
    }
    em=minx/miny;
    en=middle-em*x[1];
    a2=(int)(miny+x[1]);
    b2=(int)(minx+middle);
    for (i=1; ; i++)
        if ((double)((double)em*i+en)-((int)(em*i+en))<=prec || (double)((int)(em*i+en))-((double)em*i-en)<=prec)
        if (i!=a2 && (int)(em*i+en)>0)
        {
            a1=i;
            b1=(int)(em*i+en);
            break;
        }
    printf("%d %d %d %d\n",a1,b1,a2,b2);

    return 0;
}

int part(int p, int r)
{
    int i=p-1,j;

    for (j=p; j<=r; j++)
        if (x[j]<=x[r])
        {
            i++;
            tmp=x[i];
            x[i]=x[j];
            x[j]=tmp;
            tmp=y1[i];
            y1[i]=y1[j];
            y1[j]=tmp;
            tmp=y2[i];
            y2[i]=y2[j];
            y2[j]=tmp;
        }

    return i;
}

void sort(int p, int r)
{
    int q;

    if (p<r)
    {
       q=part(p,r);
       sort(p,q-1);
       sort(q+1,r);
    }
}
