#include <stdio.h>

int N, M, K;
int Muc[230][230];//matrix de adiac
int Q[230][230];//valoarea din intrare
int W[230][230];//semnul (0 - X; 1 - >= ; 2 - <)
int Dmin[230][230];//dif.min.necesara
int Dmax[230][230];//dif.max.necesara

int Stiva0;
int Stiva[230];
int Grad[230];
int tmp[230][230];
int Top0;
int Top[230];//nodurile, sortate topologic

int Cap[230];//capul de tabel

int Tata[230];

int SOL[230];

void Rec(int pos, int tata){
	Tata[pos] = tata;
	int a;
	for(a=1;a<=N;a++) if (Muc[pos][a] && a != tata){
		Rec(a, pos);
	}
}

void Rec2(int pos, int tata){
	if (pos <= K) SOL[pos] = Cap[pos] - SOL[tata];
	else SOL[pos] = Cap[pos] - SOL[tata] + SOL[1];
	int a;
	for(a=1;a<=N;a++) if (Muc[pos][a] && a != tata){
		Rec2(a, pos);
	}
}

void Set(int pos){
	int a;
	int sol = 2000000000;
	for(a=1;a<=N;a++) if (W[pos][a] == 2){
		if (sol > Q[pos][a]){
			sol = Q[pos][a];
		}
	}
	Cap[pos] = sol-1;
}

int main(void){
	int a,b,c;
	int a1,a2;
	int A,B;
	int x;
	FILE *e,*ee;
	e = fopen("import.in","r");
		fscanf(e, "%d %d %d", &N, &M, &K);
		for(a=1;a<N;a++){
			fscanf(e, "%d %d", &a1, &a2);
			Muc[a2][a1] = Muc[a1][a2] = 1;
		}
		for(a=1;a<=M;a++){
			fscanf(e, "%d %d", &a1, &a2);
			fscanf(e, "%d %d", &Q[a1][a2], &W[a1][a2]);
			W[a1][a2]++;
			Q[a2][a1] = Q[a1][a2];
			W[a2][a1] = W[a1][a2];
		}
	fclose(e);
	//calculare dif.min. si dif.max
	for(a=1;a<=N;a++){
		for(b=1;b<=N;b++){
			Dmin[a][b] = -2000000000;
		}
	}
	//vertical
	for(a=1;a<=K;a++){
		for(b=K+1;b<=N;b++){
			for(c=K+1;c<=N;c++){
				if (W[a][b] == 2 && W[a][c] == 1){
					if (Dmin[c][b] < Q[a][c] - Q[a][b] + 1){
						Dmin[c][b] = Q[a][c] - Q[a][b] + 1;
					}
				}
				if (W[a][b] == 1 && W[a][c] == 1){
					if (Q[a][c] - Q[a][b] > 0){
						if (Dmin[c][b] < Q[a][c] - Q[a][b]){
							Dmin[c][b] = Q[a][c] - Q[a][b];
						}
					}
				}
			}
		}
	}
	//orizontal
	for(a=K+1;a<=N;a++){
		for(b=1;b<=K;b++){
			for(c=1;c<=K;c++){
				if (W[a][b] == 2 && W[a][c] == 1){
					if (Dmin[c][b] < Q[a][c] - Q[a][b] + 1){
						Dmin[c][b] = Q[a][c] - Q[a][b] + 1;
					}
				}
				if (W[a][b] == 1 && W[a][c] == 1){
					if (Q[a][c] - Q[a][b] > 0){
						if (Dmin[c][b] < Q[a][c] - Q[a][b]){
							Dmin[c][b] = Q[a][c] - Q[a][b];
						}
					}
				}
			}
		}
	}
	//sortare topologica, dupa dif.min. si init. cap tabel
	for(a=1;a<=N;a++){
		for(b=1;b<=N;b++){
			tmp[a][b] = Dmin[a][b];
			if (tmp[a][b] != -2000000000){
				Grad[a]++;
			}
		}
	}
	for(a=1;a<=N;a++) if (Grad[a] == 0){
		Stiva[++Stiva0] = a;
	}
	for(;Stiva0;){
		Top[++Top0] = x = Stiva[Stiva0--];
		for(a=1;a<=N;a++){
			if (tmp[a][x] != -2000000000){
 				tmp[a][x] = -2000000000;
				if (!(--Grad[a])) Stiva[++Stiva0] = a;
				Set(x);
			}
		}
	}
	//calculare cap tabel
	for(a=1;a<=N;a++){ A = Top[a];
		for(b=1;b<a;b++){ B = Top[b];
			if (Dmin[A][B]){
				if (Cap[a] < Dmin[A][B] + Cap[B]){
					Cap[A] = Dmin[A][B] + Cap[B];
				}
			}
		}
	}
	Rec(1, 0);
	Rec2(1, 0);
	ee = fopen("import.out","w");
		for(a=1;a<=N;a++){
			fprintf(ee, "%d ", SOL[a]);
		}
		fprintf(ee, "\n");
	fclose(ee);
	return 0;
}

