#include<stdio.h>
#include<string.h>

#define MAX(x,y) ((x)>(y)?(x):(y))

#define MAXN 128

#define MAXC 128
int rc[MAXC];
struct nrm
{
	int c[MAXC];
	void operator += (nrm &b)
	{
		int t=0, mc = MAX(c[0], b.c[0]);
		for (int i=c[0]+1; i<=mc; ++i) c[i] = 0;
		for (int i=b.c[0]+1; i<=mc; ++i) b.c[i] = 0;
		for (int i=1; i<=mc; ++i)
		{
			t += c[i] + b.c[i];
			c[i] = t % 10;
			t /= 10;
		}
		c[0] = mc;
		if (t) c[++c[0]] = t;
	}
	void operator *= (const int b)
	{
		int t=0;
		for (int i=1; i<=c[0]; ++i)
		{
			t += c[i] * b;
			c[i] = t % 10;
			t /= 10;
		}
		while (t)
		{
			c[++c[0]] = t % 10;
			t /= 10;
		}
	}
	nrm operator * (const nrm &b)
	{
		int t;
	   memset(rc, 0, sizeof(rc));

		for (int i=1; i<=b.c[0]; ++i)
		{
			t = 0;
			for (int j=1; j<=c[0]; ++j)
			{
				t += b.c[i] * c[j];
				t += rc[i+j-1];
				rc[i+j-1] = t % 10;
				t /= 10;
			}
			rc[0] = i+c[0]-1;
			while (t)
			{
				t += rc[++rc[0]];
				rc[rc[0]] = t % 10;
				t /= 10;
			}
		}
		rc[0] = b.c[0] + c[0] - 1;
		while (rc[rc[0]+1]) ++rc[0];

		nrm r;
		for (int i=0; i<MAXC; ++i) r.c[i] = rc[i];
		return r;
	}
} d[MAXN][2]; // 0=empty 1=full

nrm solvea(int n)
{
	memset(d, 0, sizeof(d));

//	d[0][0] = d[0][1] = 1;
	d[0][0].c[0] = d[0][0].c[1] = d[0][1].c[0] = d[0][1].c[1] = 1;

	for (int i=1; i<n; ++i)
	{
		d[i][0] = d[i-1][1];
		d[i][1] = d[i-1][0];
 		d[i][1] += d[i-1][1];
	}

	return d[n-1][1];
}

nrm solveb(int n)
{
	nrm sol;
	if (n==1)
	{
		sol.c[0] = 1; sol.c[1] = 2;
	   return sol;
	}
	sol = solvea(n) * solvea(n-1);
	sol *= 2;
	return sol;
}

int solvec(int n)
{
	if (n==1) return 2;
	else return 8;
}

void afiseaza(nrm a)
{
	for (int i=a.c[0]; i>0; --i)
		printf("%d", a.c[i]);
	printf("\n");
}
void afiseaza(int a)
{
	printf("%d\n", a);
}


int main(void)
{
   freopen("perfect.in", "rt", stdin);
   freopen("perfect.out", "wt", stdout);

	char type;
	int n;
   scanf("%c %d", &type, &n);

   if (type=='A') afiseaza(solvea(n));
	else if (type=='B') afiseaza(solveb(n));
	else if (type=='C') afiseaza(solvec(n));

   return 0;
}

