var a,x,y1,y2:array[0..100000] of longint;
i,j,n:longint;
aa,bb,cc:int64;

procedure swap(i,j:longint);
var k:longint;
begin
k:=x[i];  x[i]:=x[j];   x[j]:=k;
k:=a[i];  a[i]:=a[j];   a[j]:=k;
k:=y1[i]; y1[i]:=y1[j]; y1[j]:=k;
k:=y2[i]; y2[i]:=y2[j]; y2[j]:=k;
end;

procedure update(k,nr:longint);
begin
while (2*k<=nr) and ((a[k]<a[2*k]) or (a[k]<a[2*k+1])) do
 if a[2*k]>a[2*k+1] then
                    begin
                    swap(k,2*k); k:=2*k;
                    end
                    else
                    begin
                    swap(k,2*k+1); k:=2*k+1;
                    end;
end;

procedure hsort;
var i,k,nr:longint;
begin
for i:=2 to n do
 begin
 k:=i;
 while (k>1) and (a[k]>a[k div 2]) do
  begin
  swap(k, k div 2); k:=k div 2;
  end;
 end;
nr:=n;
for i:=1 to n do
 begin
 swap(1,nr); a[nr]:=-1;
 dec(nr); update(1,nr);
 end;
end;

procedure calc(x1,y1,x2,y2:longint);
begin
aa:=y2-y1;
bb:=x1-x2;
cc:=int64(y1)*x2-int64(x1)*y2;
end;

function semn(x,y:longint):longint;
var rez:int64;
begin
rez:=aa*x+bb*y+cc;
if rez=0 then exit(0);
if rez<0 then semn:=-1
         else semn:=1;
end;

procedure vezi(a1,b1,a2,b2:longint);
var i:longint;
begin
calc(a1,b1,a2,b2);
for i:=1 to n do
 if semn(x[i], y1[i])*semn(x[i],y2[i])>0 then exit;
writeln(a1,' ',b1,' ',a2,' ',b2);
close(input); close(output);
halt(0);
end;

procedure check(p1,p2:longint);
begin
vezi(x[p1],y1[p1],x[p2],y2[p2]);
vezi(x[p1],y2[p1],x[p2],y1[p2]);
end;

procedure check2(p1,p2:longint);
begin
vezi(x[p1],y2[p1],x[p2],y2[p2]);
vezi(x[p1],y1[p1],x[p2],y1[p2]);
end;

procedure aprox(val:longint);
var i,j:longint;
x1,ys1,yj1,x2,ys2,yj2:int64;
begin
if n<1000 then exit;
x1:=0; ys1:=0; yj1:=0;
x2:=0; ys2:=0; yj2:=0;
for i:=1 to val do
 begin
 inc(x1,x[i]); inc(ys1, y1[i]); inc(yj1, y2[i]);
 end;
for j:=n-val+1 to n do
 begin
 inc(x2,x[i]); inc(ys2, y1[i]); inc(yj2, y2[i]);
 end;
x1:=x1 div val; ys1:=ys1 div val; yj1:=yj1 div val;
x2:=x2 div val; ys2:=ys2 div val; yj2:=yj2 div val;
vezi(x1,yj1,x2,ys2);
vezi(x1,ys1,x2,yj1);
vezi(x1,yj1,x2,yj2);
vezi(x1,ys1,x2,ys2);
end;

begin
assign(input,'oypara.in'); reset(input);
assign(output,'oypara.out'); rewrite(output);
readln(n);
for i:=1 to n do readln(x[i], y1[i], y2[i]);
a:=y1; hsort;
vezi(x[1],y1[1],x[n],y2[n]);
vezi(x[1],y2[1],x[n],y1[n]);
aprox(3); aprox(50); aprox(100); aprox(300);
for i:=1 to n-1 do
 for j:=n downto i+1 do
 check(i,j);
for i:=1 to n-1 do
 for j:=i+1 to n do
 check(i,j);
close(input); close(output);
end.
