#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <vector>
using namespace std;

#define FOR(i, a, b) for (i = (a); i <= (b); i ++)
#define REP(i, n)    for (i =   0; i <  (n); i ++)
#define FORI(i, x)   for (i = (x).begin(); i != (x).end(); i ++)
#define mp make_pair
#define pb push_back

#define NMAX 225
#define MMAX NMAX * NMAX

vector<int> adj1[NMAX];
vector<int> adj2[NMAX];
int N, M, K, i, j, k, stp, a, b, c, dd;
int d[NMAX], Ans[NMAX], seen[NMAX];
int x[MMAX], y[MMAX], w[MMAX];

void read(void)
{
    freopen("import.in", "r", stdin);
    freopen("import.out", "w", stdout);
    scanf("%d %d %d", &N, &M, &K);
    REP(k, N - 1)
    {
        scanf("%d %d", &i, &j);
        if (i <= K && j <= K)
            adj1[i].pb(j), adj1[j].pb(i);
        else
            adj2[i].pb(j), adj2[j].pb(i);
    }

    REP(k, M)
    {
        scanf("%d %d %d %d", &a, &b, &c, &dd);
        if (dd == 0)
            x[k] = b, y[k] = a, w[k] = - c;
        else
            x[k] = a, y[k] = b, w[k] = c - 1;
    }
}

void relax_all(void)
{
    int i;

//    REP(i, N)
//        if (d[i] > 0)
//            d[i] = 0;

    REP(i, M)
    {
        int xx = x[i], yy = y[i], ww = w[i];
        if (d[xx] + ww <= d[yy])
            d[yy] = d[xx] + ww;
    }
}

void dfs1(int x)
{
    vector<int> :: iterator it;
    seen[x] = 1;
    FORI(it, adj1[x])
        if (!seen[*it])
        {
            Ans[*it] = d[*it] - d[x];
            dfs1(*it);
        }
}

void dfs2(int x)
{
    vector<int> :: iterator it;
    seen[x] = 1;
    FORI(it, adj2[x])
        if (!seen[*it])
        {
            Ans[*it] = d[*it] - d[x];
            dfs2(*it);
        }
}


void solve(void)
{
    int i;
    memset(d, 0, sizeof(d));
    REP(i, N)
        relax_all();
/*
    REP(i, M)
    {
        if (d[x[i]] + w[i] < d[y[i]])
            printf("bad!!!!!!");
    }
*/
        
    FOR(i, K + 1, N)
        d[i] = - d[i];


    memset(Ans, 0, sizeof(Ans));
    Ans[1] = d[1];
    memset(seen, 0, sizeof(seen));
    dfs1(1);
    seen[1] = 0;
    dfs2(1);

    FOR(i, 1, N - 1)
        printf("%d ", Ans[i]);
    printf("%d\n", Ans[N]);
}

void gen(void)
{
    srand(666);
    freopen("import.in", "w", stdout);
    N = 222, K = 100, M = (K *(N - K)) / 10;
    printf("%d %d %d\n", N, M, K);
    int i;
    FOR(i, 2, N)
    {
        printf("%d %d\n", i, 1 + (rand() % (i - 1)));
    }

    FOR(i, 1, M)
    {
        printf("%d %d %d %d\n", K + 1 + rand() % (N - K), 1 + rand() % K, (rand() % 2000000000) - 1000000000, rand() % 2);
    }
}

int main(void)
{
//    gen();
//    return 0;
    read();
    solve();
    return 0;
}
