#include <stdio.h>
#include <stdlib.h>
#define nmax 100005
FILE *fin,*fout;

long n,x,y,este;

typedef struct segment
{
 long x,y1,y2,nj,ns;
}segment;
segment a[nmax];

int comp1(const void *a,const void *b)
{
 if ( (*(segment*)a).x > (*(segment*)b).x ) return 1;
 else if ( (*(segment*)a).x < (*(segment*)b).x ) return -1;
 return 0;
}
long ay,by;
int comp2(const void *a,const void *b)
{
 ay=(*(segment*)a).y2-(*(segment*)a).y1;
 by=(*(segment*)b).y2-(*(segment*)b).y1;

 if (ay>by) return 1;
 else if (ay<by) return -1;
 else return 0;
}
long mse(long x1,long y1,long x2,long y2,long x3,long y3)
{
 if ((double)y1>(double)(x1-x2)/(x3-x2)*(y3-y2)+y2-0.00001) return 1;
 return 0;
}
long mje(long x1,long y1,long x2,long y2,long x3,long y3)
{
 if ((double)y1<(double)(x1-x2)/(x3-x2)*(y3-y2)+y2+0.00001) return 1;
 return 0;
}

void scoate(long j,long k)
{
 long i;
 for (i=j+1;i<k;i++)
 {
  if (mse(a[i].x,a[i].y2,a[j].x,a[j].y2,a[k].x,a[k].y2)) a[i].ns=1;
  if (mje(a[i].x,a[i].y1,a[j].x,a[j].y1,a[k].x,a[k].y1)) a[i].nj=1;
 }
}

void pot(long x1,long y1,long x2,long y2)
{
 long i;
 if (x1>x2)
 {
  i=x1; x1=x2; x2=i;
  i=y1; y1=y2; y2=i;  
 }
 if (x1==x2 && y1==y2) return;
 for (i=0;i<n;i++) if (!mse(a[i].x,a[i].y2,x1,y1,x2,y2) || !mje(a[i].x,a[i].y1,x1,y1,x2,y2))
 {
  return;
 }
 fprintf(fout,"%ld %ld %ld %ld\n",x1,y1,x2,y2);
 fclose(fin);
 fclose(fout);
 exit(0);
}
int main()
{
 long i,j;
 
 fin=fopen("oypara.in","rt");
 fout=fopen("oypara.out","wt");
 
 fscanf(fin,"%ld",&n);
 for (i=0;i<n;i++) fscanf(fin,"%ld %ld %ld",&a[i].x,&a[i].y1,&a[i].y2);

 qsort(a,n,sizeof(a[0]),comp1);

 for (i=0;i<3 && i<n;i++)
 for (j=0;j<3 && j<n;j++) if (i<n-1-j)
 {
  scoate(i,n-1-j);
 }

 qsort(a,n,sizeof(a[0]),comp2);

 for (i=0;i<10 && i<n;i++)
 for (j=i+1;j<10 && j<n;j++)
 {
  if (!a[i].nj && !a[j].nj) pot(a[i].x,a[i].y1,a[j].x,a[j].y1);
  if (!a[i].nj && !a[j].ns) pot(a[i].x,a[i].y1,a[j].x,a[j].y2);
  if (!a[i].ns && !a[j].nj) pot(a[i].x,a[i].y2,a[j].x,a[j].y1);
  if (!a[i].ns && !a[j].ns) pot(a[i].x,a[i].y2,a[j].x,a[j].y2);
 }
 for (i=0;i<n;i++)
 for (j=i+1;j<n;j++) if (i>9 || j>9 )
 {
  if (!a[i].nj && !a[j].nj) pot(a[i].x,a[i].y1,a[j].x,a[j].y1);
  if (!a[i].nj && !a[j].ns) pot(a[i].x,a[i].y1,a[j].x,a[j].y2);
  if (!a[i].ns && !a[j].nj) pot(a[i].x,a[i].y2,a[j].x,a[j].y1);
  if (!a[i].ns && !a[j].ns) pot(a[i].x,a[i].y2,a[j].x,a[j].y2);
 }
 fclose(fin);
 fclose(fout);
 return 0;
}

