#include <stdio.h>

#define NMAX 100001
#define maxim(a,b) ((a>b)?(a):(b))
#define minim(a,b) ((a>b)?(b):(a))

FILE *fin,*fout;

int N;
struct segment
{long x,y1,y2;
}seg[NMAX+1];
struct punct
{long x,y;
}C1,C2;
const long pin=100000000;

int comp(segment A,segment B)
{return ((A.x<B.x)||(A.x==B.x&&A.y1<B.y1));
}
void Combina(int vf,int nn)
{int baza;
 segment val=seg[vf];
 for (baza=vf<<1;baza<=nn;baza<<=1)
     {if (baza<nn&&comp(seg[baza],seg[baza+1])) ++baza;
      if (comp(val,seg[baza])) {seg[vf]=seg[baza];vf=baza;}
      else break;
     }
 seg[vf]=val;
}
void Heap()
{int i;
 for (i=N/2;i>=1;--i) Combina(i,N);
}
void Heapsort()
{int i;
 segment aux;
 Heap();
 for (i=N;i>1;--i)
     {aux=seg[i];seg[i]=seg[1];seg[1]=aux;
      Combina(1,i-1);
     }
}
int orient(punct A,punct B,punct C)
{long long val,aa,bb,cc;
 aa=A.y-B.y;
 bb=B.x-A.x;
 cc=A.x*B.y-A.y*B.x;
 val=C.x*aa+C.y*bb+cc;
 if (val>0) return 1;
 else if (!val) return 0;
 else return -1;
}

int main()
{int bol,i,miny,maxy,salt,p1,p2,orr;
 punct A,B,aux;
 fin=fopen("oypara.in","r");
 fscanf(fin,"%d",&N);
 for (i=1;i<=N;++i)
     {fscanf(fin,"%ld %ld %ld",&seg[i].x,&seg[i].y1,&seg[i].y2);
     }
 fclose(fin);
 Heapsort();
 for (i=2,salt=0;i<=N;++i)
     {if (seg[i].x==seg[i-1].x)
         {if (seg[i-1-salt].y1<seg[i].y1) seg[i-1-salt].y1=seg[i].y1;
          if (seg[i-1-salt].y2>seg[i].y2) seg[i-1-salt].y2=seg[i].y2;
          ++salt;
         }
      else seg[i-salt]=seg[i];
     }
 N-=salt;
 miny=seg[1].y1;p1=1;maxy=-1;
 for (i=1;i<=N;++i)
     {if (miny>seg[i].y1) {p1=i;miny=seg[i].y1;}
      if (maxy<seg[i].y1) {p2=i;maxy=seg[i].y1;}
     }
 C1.x=seg[p1].x;
 C2.x=seg[p2].x;
 C1.y=miny;
 C2.y=maxy;
 bol=0;
 while (!bol)
       {bol=1;p1=p2=0;
        miny=pin;maxy=-1;
        if (C2.y<C1.y) {aux=C1;C1=C2;C2=aux;}
        if (C2.x<C1.x) {aux=C1;C1=C2;C2=aux;}
        for (i=1;i<=N;++i)
            {A.x=B.x=seg[i].x;
             A.y=seg[i].y2;
             B.y=seg[i].y1;
             orr=orient(C1,C2,A);
             if (orr<0)
                {bol=0;
                 if (maxy<A.y) {maxy=A.y;p2=i;}
                }
             else
                 {orr=orient(C1,C2,B);
                  if (orr>0)
                     {bol=0;
                      if (miny>B.y) {miny=B.y;p1=i;}
                     }
                 }
            }
        if (!bol)
           {C1=C2;
            if (p1) {C2.x=seg[p1].x;
                     C2.y=miny;
                    }
            else {C2.x=seg[p2].x;
                  C2.y=maxy;
                 }
           }
       }
 fout=fopen("oypara.out","w");
 fprintf(fout,"%ld %ld %ld %ld\n",C1.x,C1.y,C2.x,C2.y);
 fclose(fout);
 return 0;
}
