#include <stdio.h>

#include <algorithm>
using namespace std;

#define NMAX 30100
#define KMAX 1100
#define INF 666666666

int nbaze[NMAX], nacid[NMAX], S[KMAX];
int i, j, k, x, M, N, B, P, K, vmin, vmacid, vmbaza, extra;

int main()
{
	int T;

	freopen("ab.in", "r", stdin);
	freopen("ab.out", "w", stdout);

	scanf("%d", &T);
	while (T--)
	{
		scanf("%d %d %d", &M, &N, &K);
		for (i = 1; i <= K; i++)
			scanf("%d", &S[i]);

		sort(&S[1], &S[K + 1]);
		
		P = nbaze[0] = 0;
		for (i = 1; i <= M; i++)
		{
			scanf("%d", &B);
			nbaze[i] = nbaze[i - 1] + B;
		
			while (B--)
			{
				P++;
				nacid[P] = i;
			}
		}

		// scapa de bazele care nu reactioneaza cu nici un acid
		extra = (N - P) * S[1];
		N = P;

		fprintf(stderr, "*\n");

		// coloreaza cu S[1] un acid

		vmacid = INF - 1;
		//fprintf(stderr, "acizi\n");

		for (i = 0; i <= M; i++)
		{
			x = (i + N - nbaze[i]) * S[1];

			if (i == M)
				x += nbaze[i] * S[2];
			else // i < M
			if (nbaze[i] == 0)
				x += (M - i) * S[2];
			else // (M - i) > 0 && nbaze[i] > 0
			if (K > 2)
			{
				if (M - i > nbaze[i])
					x += (M - i) * S[2] + nbaze[i] * S[3];
				else
					x += (M - i) * S[3] + nbaze[i] * S[2];
			}
			else
				x = INF;

			if (x <= vmacid)
			{
				vmacid = x;
				//fprintf(stderr, "acid %d -> %d\n", i, vmacid);
			}
		}

		// coloreaza cu S[1] o baza

		vmbaza = INF - 1;
		//fprintf(stderr, "baze\n");

		for (i = N; i >= 1; i--)
		{
			x = (N - i + 1 + nacid[i] - 1) * S[1];

			if (i == 1)
				x += (M - nacid[i] + 1) * S[2];
			else
			if (K > 2)
			{
				if (M - nacid[i] + 1 > i - 1)
					x += (M - nacid[i] + 1) * S[2] + (i - 1) * S[3];
				else
					x += (M - nacid[i] + 1) * S[3] + (i - 1) * S[2];
			}
			else
				x = INF;

			if (x <= vmbaza)
			{
				vmbaza = x;
				//fprintf(stderr, "baza %d -> %d\n", i, vmbaza);
			}
		}

		if (vmacid < vmbaza)
			vmin = vmacid;
		else
			vmin = vmbaza;

		printf("%d\n", vmin + extra);
	}

	return 0;
}