#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>

#define NMAX 260

int w[NMAX], A[NMAX][NMAX], p[NMAX], used[NMAX], pcrit[NMAX], v[NMAX], clq[NMAX][NMAX], nclq[NMAX], okclq[NMAX], okcrit[NMAX];
int i, j, k, l, N, M, nc, ncrit, iscrit, last, dmin, dmax, size, maxsize, prob, minclq;

int main()
{
	freopen("soc2.in", "w", stdout);

	N = 256;
	ncrit = 200;
	dmin = 15;
	dmax = 15;

	prob = 100;
	minclq = 10;

	// permuta aleator nodurile
	srand(68/*time(NULL)*/);

	memset(used, 0, sizeof(used));

	for (i = 1; i <= N; i++)
	{
		do
		{
			j = 1 + rand() % N;
		}
		while (used[j]);

		p[i] = j;
		used[j] = 1;
	}

	// genereaza nodurile acceptabile ca noduri critice

	okcrit[1] = 1;

	for (i = 2; i <= ncrit; i++)
	{
		do
		{
			j = 1 + rand() % N;
		}
		while (okcrit[j]);

		okcrit[j] = 1;
	}

	// genereaza graful cordal

	memset(A, 0, sizeof(A));

	nc = 1;
	nclq[1] = maxsize = 2;
	clq[1][1] = p[1];
	clq[1][2] = p[2];
	okclq[1] = 1;
	A[p[1]][p[2]] = A[p[2]][p[1]] = 1;

	last = 1;

	for (i = 3; i <= N; i++)
	{
		if (i - last >= dmax)
		{
			iscrit = 1;

			//fprintf(stderr, "i: diff = %d\n", i - last);
		}
		else
		if (i - last >= dmin)
		{
			k = rand() % 1000;

			if (k <= prob)
				iscrit = 1;
			else
				iscrit = 0;
		}
		else
			iscrit = 0;

		fprintf(stderr, "%d : iscrit = %d\n", i, iscrit);

		if (iscrit) // incepe o componenta biconexa noua
		{
			do
			{
				j = 1 + rand() % (i - 1);
			}
			while (!okcrit[j]);

			A[p[i]][p[j]] = A[p[j]][p[i]] = 1;

			for (k = 1; k <= nc; k++)
				okclq[k] = 0;

			nc++;
			nclq[nc] = 2;
			clq[nc][1] = p[i];
			clq[nc][2] = p[j];
			okclq[nc] = 1;

			maxsize = 2;
		
			last = i - 1;
		}
		else // adauga la componenta biconexa curenta
		{
			// cauta o clica "ok" la care sa adaugi nodul curent

			if (i == 53)
			{
				fprintf(stderr, "*\n");
			}

			do
			{
				k = 1 + (rand() % nc);
				size = (int)(((40.0 + rand() % 61) / 100.0) * maxsize);

				if (maxsize < minclq)
					size = maxsize;

				if (size > maxsize)
					size = maxsize;

				if (size < 2)
					size = 2;
			}
			while (!okclq[k] || nclq[k] < size /*|| (clq[k][nclq[k]] != p[i - 1] && clq[k][nclq[k]] != p[i - 2])*/);

			fprintf(stderr, "%d: am selectat clica %d (size = %d / maxsize = %d)\n", i, k, size, maxsize);

			// genereaza vecinii nodului i din cadrul clicii selectate
			
			if (size > 3)
			{
				//fprintf(stderr, "*\n");
			}

			memset(used, 0, sizeof(used));

			v[1] = clq[k][nclq[k]];
			used[nclq[k]] = 1;

			for (l = 2; l <= size; l++)
			{
				do
				{
					j = 1 + rand() % nclq[k];
				}
				while (used[j]);

				v[l] = clq[k][j];
				used[j] = 1;
			}

			for (l = 1; l <= size; l++)
				A[p[i]][v[l]] = A[v[l]][p[i]] = 1;

			if (size == nclq[k])
			{
				nclq[k]++;
				clq[k][nclq[k]] = p[i];

				if (nclq[k] > maxsize)
					maxsize = nclq[k];
			}
			else
			{
				nc++;
				nclq[nc] = size + 1;

				for (k = 1; k <= size; k++)
					clq[nc][k] = v[k];

				clq[nc][nclq[nc]] = p[i];

				if (nclq[nc] > maxsize)
					maxsize = nclq[nc];

				okclq[nc] = 1;
			}
		}

		fprintf(stderr, "%d/%d\n", i, N);
	}

	M = 0;
	for (i = 1; i < N; i++)
		for (j = i + 1; j <= N; j++)
			if (A[i][j])
				M++;

	printf("%d %d\n", N, M);

	// generate weights
	for (i = 1; i <= N; i++)
	{
		w[i] = 100000 + (100 + rand() % 800) * (100 + rand() % 800);

		//w[i] = i;

		printf("%d", w[i]);

		if (i < N)
			printf(" ");
	}

	printf("\n");

	for (i = 1; i < N; i++)
		for (j = i + 1; j <= N; j++)
			if (A[i][j])
				printf("%d %d\n", i, j);

	return 0;
}