#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define NMAX 260

int A[NMAX][NMAX], w[NMAX], used[NMAX], sol[NMAX];
int i, j, k, N, M, oksol, concsol, csol, points, sum;

void err(char *msg)
{
	printf("%d %s\n", points, msg);
	exit(0);
}

int main()
{
	freopen("soc2.in", "r", stdin);

	scanf("%d %d", &N, &M);

	for (i = 1; i <= N; i++)
		scanf("%d", &w[i]);

	memset(A, 0, sizeof(A));

	while (M--)
	{
		scanf("%d %d", &i, &j);
		A[i][j] = A[j][i] = 1;
	}

	freopen("soc2.ok", "r", stdin);
	scanf("%d", &oksol);

	freopen("soc2.out", "r", stdin);

	points = 0;

	if (scanf("%d", &concsol) != 1)
		err("format incorect pt fisierul de iesire sau fisier de iesire gol");

	if (concsol > oksol)
		points = 0;
	else
	if (concsol == oksol)
		points = 3;
	else
		err("capitalul societatii este prea mic :(");
		//points = 0;

	if (scanf("%d", &csol) != 1)
		err("nu ati afisat si actionarii societatii sau i-ati afisat intr-un format gresit");

	if (csol < 0 || csol > N)
		err("valoare incorecta pentru numarul de actionari");

	memset(used, 0, sizeof(used));

	for (i = 1; i <= csol; i++)
	{
		if (scanf("%d", &sol[i]) != 1)
			err("nu ati afisat solutia completa sau ati afisat-o intr-un format incorect");

		if (sol[i] < 1 || sol[i] > N)
			err("ati afisat un actionar inexistent");

		used[sol[i]] = 1;
	}

	sum = 0;
	for (i = 1; i <= N; i++)
		if (used[i])
			sum += w[i];

	if (sum != concsol)
		err("actionarii afisati nu au capitalul specificat");

	for (i = 1; i < N; i++)
		for (j = i + 1; j <= N; j++)
			if (A[i][j] && used[i] && used[j])
				err("solutie incorecta");

	points += 2;

	if (concsol > oksol)
		points = 1001;

	err("ok");

	return 0;
}
