{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

Program _soc_;

const filein='soc2.in';
      fileout='soc2.out';
      MAXN=256;
      maxperm=2000;

type plist=^list;
     list=record
            vec:integer;
            urm:plist;
          end;

var sol,sact,perm,indepset,ncol,lstset:array[1..MAXN] of longint;
    e,asoc,deg,lst,lst2,marc,dego,nin,tata:array[1..MAXN] of longint;
    used:array[1..MAXN] of boolean;
    edge:array[1..MAXN] of plist;
    a:array[1..MAXN,1..MAXN] of boolean;
    min,sum,i,j,k,m,n,p,nset,v,nv,ncomp,nedge,ninset,maxset,maxiter:longint;
    aux:plist;
    ok,oki:boolean;

procedure print;
begin
assign(output,fileout);
rewrite(output);

min:=0;
for i:=1 to n do
  if (sol[i]=1) then
    min:=min+e[i];
writeln(min);

min:=0;
for i:=1 to n do
  min:=min+sol[i];

write(min,#13,#10);
for i:=1 to n do
  if (sol[i]=1) then
    write(i,' ');
write(#13,#10);

close(output);

halt(0);
end;


procedure randompermutations(n:longint);
begin
randomize;
for k:=1 to maxperm do
  begin
    fillchar(used,sizeof(used),false);
    for i:=1 to n do
      begin
        repeat
          j:=random(n)+1;
        until (not used[j]);

        perm[i]:=j;
        used[j]:=true;
      end;

    if (k=1) then
      begin
        for i:=1 to n-1 do
         for j:=i+1 to n do
           if (e[lst[perm[i]]]<e[lst[perm[j]]]) then
             begin
               p:=perm[i];
               perm[i]:=perm[j];
               perm[j]:=p;
             end;
      end;

    sum:=0;
    fillchar(sact,sizeof(sact),0);
    for i:=1 to n do
      begin
        ok:=true;
        aux:=edge[lst[perm[i]]];

        while (aux<>nil) do
          begin
            j:=aux^.vec;
            if (sact[j]>0) then
              begin
                ok:=false; break;
              end;

            aux:=aux^.urm;
          end;

        if (ok) then
          begin
            sact[lst[perm[i]]]:=1;
            sum:=sum+e[lst[perm[i]]];
          end;
      end;

    if (sum>min) then
      begin
        min:=sum;
        for i:=1 to n do
          sol[lst[i]]:=sact[lst[i]];
      end;
  end;
end;

procedure df(nod:longint);
var aux:plist;
    i:longint;
begin
marc[nod]:=ncomp;
aux:=edge[nod];
while (aux<>nil) do
  begin
    i:=aux^.vec;
    inc(nedge);

    if (marc[i]=0) then
      df(i);

    aux:=aux^.urm;
  end;
end;

begin
assign(input,filein);
reset(input);
read(n,m);

for i:=1 to n do
  read(e[i]);

fillchar(a,sizeof(a),false);
fillchar(deg,sizeof(deg),0);
for i:=1 to n do
  edge[i]:=nil;


for k:=1 to m do
  begin
    read(i,j);
    a[i,j]:=true;
    a[j,i]:=true;
  end;
close(input);

for i:=1 to n-1 do
  for j:=i+1 to n do
    if (a[i,j]) then
      begin
        new(aux);
        aux^.vec:=j;
        aux^.urm:=edge[i];
        edge[i]:=aux;

        new(aux);
        aux^.vec:=i;
        aux^.urm:=edge[j];
        edge[j]:=aux;

        inc(deg[i]);
        inc(deg[j]);
      end;

fillchar(sol,sizeof(sol),0);
fillchar(marc,sizeof(marc),0);
ncomp:=0;
for v:=1 to n do
  if (marc[v]=0) then
    begin
      inc(ncomp);
      nedge:=0;
      df(v);
      nedge:=nedge shr 1;

      nv:=0;
      for i:=1 to n do
        if (marc[i]=ncomp) then
          begin
            inc(nv);
            lst[nv]:=i;
            lst2[nv]:=i;
          end;

      min:=0;

      randompermutations(nv);
    end;

print;
end.