#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#define maxim(a , b) ((a) < (b) ? (b) : (a))

#define NMAX 260
#define NPERM 1000

int A[NMAX][NMAX], w[NMAX], vizitat[NMAX], marcat[NMAX], max[NMAX][2];
int i, j, k, N, M, cnt;

void df(int x)
{
	int y;

	vizitat[x] = 1;

	max[x][0] = 0;
	max[x][1] = w[x];

	for (y = 1; y <= N; y++)
		if (A[x][y] && !vizitat[y])
		{
			df(y);

			max[x][1] += max[y][0];
			max[x][0] += maxim(max[y][0], max[y][1]);
		}
}

void make_sol(int x, int selx)
{
	int y;

	vizitat[x] = 1;
	marcat[x] = selx;

	for (y = 1; y <= N; y++)
		if (A[x][y] && !vizitat[y])
		{
			if (selx)
				make_sol(y, 0);
			else
			if (max[y][0] > max[y][1])
				make_sol(y, 0);
			else
				make_sol(y, 1);
		}
}

int main()
{
	freopen("soc2.in", "r", stdin);

	scanf("%d %d", &N, &M);

	for (i = 1; i <= N; i++)
	{
		scanf("%d", &k);
		w[i] = k;
	}

	memset(A, 0, sizeof(A));

	while (M--)
	{
		scanf("%d %d", &i, &j);
		A[i][j] = A[j][i] = 1;
	}

	memset(vizitat, 0, sizeof(vizitat));

	df(1);

	freopen("soc2.out", "w", stdout);

	if (max[1][0] > max[1][1])
	{
		printf("%d\n", max[1][0]);
		
		memset(marcat, 0, sizeof(marcat));
		memset(vizitat, 0, sizeof(vizitat));

		make_sol(1, 0);
	}
	else
	{
		printf("%d\n", max[1][1]);

		memset(marcat, 0, sizeof(marcat));
		memset(vizitat, 0, sizeof(vizitat));

		make_sol(1, 1);
	}

	cnt = 0;
	for (i = 1; i <= N; i++)
		if (marcat[i])
			cnt++;

	printf("%d\n", cnt);
	for (i = 1; i <= N; i++)
		if (marcat[i])
			printf("%d ", i);

	printf("\n");

	return 0;
}
