#include <cstdio>
#include <bitset>

using namespace std;

#define maxn 256
#define maxm 256

int N, M, K;
int edg[maxm][3];
int deg[maxn];

bitset<maxm> eq[maxn];
bool sec[maxm], val[maxm];

void read_data()
{
	int i;
	scanf ("%d%d%d", &N, &M, &K); K --;
	for (i = 0; i < M; i++) {
		scanf ("%d%d%d", edg[i], edg[i] + 1, edg[i] + 2);
		edg[i][0] --, edg[i][1] --;

    }
}

int viz[maxn];
void df(int node)
{
    int i;
    viz[node] = 1;
    for (i = 0; i < M; i++) {
       if (edg[i][0] == node && viz[edg[i][1]] == 0)
          df (edg[i][1]);
       if (edg[i][1] == node && viz[edg[i][0]] == 0)
          df (edg[i][0]);
    }
}

void fix_conex()
{
    int i;
    df(1);
    for (i = 0; i < M; i++)
    if (viz[edg[i][0]] == 0)
       edg[i][2] = 1;
}

void make_eq()
{
    int i;
    for (i = 0; i < M; i++) {
      if (edg[i][2] == 2)
         eq[edg[i][0]][M] = !eq[edg[i][0]][M],
         eq[edg[i][1]][M] = !eq[edg[i][1]][M];
      if (edg[i][2] == 0)
         eq[edg[i][0]][i] = true,
         eq[edg[i][1]][i] = true;

      val[i] = edg[i][2] == 2;
    }
}

void solve()
{
	int ieq, cvar, j, i, count = 0, ceq;
	bitset<maxm> baux;

	for (ieq = 0, cvar = M - 1; cvar >= 0; cvar--) {
		for (j = ieq; j < N && !eq[j][cvar]; j++);
		sec[cvar] = (j == N);
		if (sec[cvar]) continue;
		
		baux = eq[j]; eq[j] = eq[ieq]; eq[ieq] = baux;
		for (j = ieq + 1; j < N; j++)
		if (eq[j][cvar])
			eq[j] ^= eq[ieq];
		ieq++;
	}

	for (i = 0; i < N; i++) {
		for (j = 0; j <= M && eq[i][j] == false; j++);
		if (j == M) { printf ("No solution!!!\n"); return; } // 0 = 1
	}
	
	for (i = 0; i < M; i++)
	if (sec[i] && edg[i][2] == 0)
		count++;
//	printf ("count: %d\n", count);
	if (count < 30 && 1 << count <= K) {
		printf ("K prea mare !!!\n");
		return;
	}

	for (i = M - 1; i >= 0; i--)
	if (sec[i] && edg[i][2] == 0) {
		val[i] = K % 2 ? true : false; K /= 2;
		for (j = 0; j < N; j++)
		if (eq[j][i])
			eq[j][i] = false,
			eq[j][M] = val[i] ? !eq[j][M] : eq[j][M];
	}
	for (cvar = 0, ceq = N - 1; cvar < M; cvar ++) {
		if (sec[cvar]) continue;
		for (; ! eq[ceq][cvar]; ceq --);
		val[cvar] = eq[ceq][M];
		for (j = 0; j < N; j++)
		if (eq[j][cvar])
			eq[j][cvar] = false,
			eq[j][M] = val[cvar] ? ! eq[j][M] : eq[j][M];
	}
	for (i = 0; i < M; i++)
		printf ("%s", val[i] ? "R" : "A");
	printf ("\n");
}

int main(void)
{
   freopen ("bcolor.in", "rt", stdin);
   freopen ("bcolor.out", "wt", stdout);

   read_data();
   fix_conex();
   make_eq();
   solve();

   return 0;
}

