#include <stdio.h>
#include <string.h>

#define MAXN (1 << 23)

int N;
char A[MAXN];

int solve(int x)
{
    int i, c, t, cnt = 0, prev = 0, ok = 0, poz = (1<<(N-1));

    if(A[x] != -1)
        return A[x];
        
    for(i = 1; i <= N; i++, poz >>= 1)
    {
        if(poz & x)
        {
            cnt++;
            if(prev == 1)
                ok = 1;
            else
                prev = 1;
        }
        else
        {
            if(ok)
            {
                t = x | poz, t = t ^ (poz<<1) ^ (poz<<2);
                c = solve(t);
                if(c)
                    return A[x] = 1;
            }
            prev = ok = 0;
        }
    }

    if(cnt == 1)
        return A[x] = 1;

    for(poz = 1, prev = 0, ok = 0, i = N; i >= 1; poz <<= 1, i--)
    {
        if(poz & x)
        {
            if(prev == 1)
                ok = 1;
            else
                prev = 1;
        }
        else
        {
            if(ok)
            {
                t = x | poz, t = t ^ (poz>>1) ^ (poz>>2);
                c = solve(t);
                if(c)
                    return A[x] = 1;
            }
            prev = ok = 0;
        }
    }
    
    return A[x] = 0;
}

int main(void)
{
    int i, j, T, num;
    char sir[2048];

    freopen("peg.in", "rt", stdin);
    freopen("peg.out", "wt", stdout);

    scanf("%d\n", &T);

    for(i = 1; i <= T; i++)
    {
        scanf("%s\n", &sir), N = strlen(sir), num = 0;

        for(j = 0; j < N; j++)
            num = num * 2 + (sir[j]-48);

        for(j = 0; j < (1<<N); j++)
            A[j] = -1;

        A[0] = 0, printf("%d\n", solve(num));
    }

    return 0;
}

    


        


