#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define MAXN 310
#define Q 4123477
#define START 111

typedef struct t_fin
{
	int l, c, val;
} fin;

void read_and_solve(void);
void solve(void);
int ok(int l);
int cmp(const void *k1, const void *k2);

int M, N, K, A[MAXN][MAXN], H1[MAXN][MAXN], H2[MAXN][MAXN], ind, S[MAXN][MAXN],
	S2[MAXN][MAXN], ind, urm[MAXN * MAXN];
char cnt[Q];
fin F[MAXN * MAXN];

int main(void)
{
	freopen("poze.in", "r", stdin);
    freopen("poze.out", "w", stdout);

    read_and_solve();

    return 0;
}

void read_and_solve(void)
{
	int t, i, j;

    for (scanf("%d", &t); t; t--)
    {
		scanf("%d %d %d", &M, &N, &K);
        for (i = 0; i < M; i++)
        	for (j = 0; j < N; j++)
            	scanf("%d", &A[i][j]), A[i][j]++;

		for (i = 0; i < M; i++)
        	for (j = 0; j < N; j++)
            	S[i][j] = (j ? S[i][j - 1] : 0) + A[i][j];

		solve();
    }
}

void solve(void)
{
	int l, pas;

 	for (pas = 1; pas <= MAXN; pas <<= 1);

    for (l = 0; pas; pas >>= 1)
    	if (ok(l + pas))
        	l += pas;

	printf("%d\n", l);
}

int ok(int l)
{
	int i, j, sum, nr;

    if (l > M || l > N)
    	return 0;

	memset(H1, 0, sizeof(H1));
    memset(H2, 0, sizeof(H2));
    memset(cnt, 0, sizeof(cnt));

    for (i = 0; i < M; i++)
    {
    	for (j = 0; j < l; j++)
        	H1[i][0] = (H1[i][0] + (START + j) * A[i][j]) % Q;
		for (j = 1; j + l - 1 < N; j++)
        {
        	H1[i][j] = (H1[i][j - 1] + Q - (S[i][j + l - 2] - S[i][j - 1]) % Q) % Q;
            H1[i][j] = (H1[i][j] + Q - (A[i][j - 1] * START) % Q) % Q;
			H1[i][j] = (H1[i][j] + (START + l - 1) * A[i][j + l - 1]) % Q;
        }
    }

    for (j = 0; j + l - 1 < N; j++)
    {
    	sum = 0;
    	for (i = 0; i < l; i++)
        	H2[0][j] = (H2[0][j] + (START + i) *  H1[i][j]) % Q, sum += H1[i][j], sum %= Q;
		for (i = 1; i + l - 1 < M; i++)
        {
        	H2[i][j] = (H2[i - 1][j] + Q - (START * H1[i - 1][j]) % Q) % Q;
            sum = (sum + Q - H1[i - 1][j]) % Q;
            H2[i][j] = (H2[i][j] + Q - sum) % Q;
			H2[i][j] = (H2[i][j] + (START + l - 1) * H1[i + l - 1][j]) % Q;
            sum = (sum + H1[i + l - 1][j]) % Q;
		}
    }

    for (i = ind = 0; i + l - 1 < M; i++)
    	for (j = 0; j + l - 1 < N; j++)
        {
        	cnt[H2[i][j]]++;
            if (cnt[H2[i][j]] >= K)
            	return 1;
		}

	return 0;
}

int cmp(const void *k1, const void *k2)
{
	fin *a1 = (fin *) k1, *a2 = (fin *) k2;

    return a1 -> val - a2 -> val;
}
