#include <stdio.h>
#include <map>
#include <string>
#include <vector>

using namespace std;

#define MAX_N 205
#define FIN "bcolor.in"
#define FOUT "bcolor.out"

int N, M, K, G[MAX_N][MAX_N], type[MAX_N][MAX_N], E[MAX_N][3];
vector<string> sol;
map<string, bool> H;

void bkt(int n, int nr)
{
    int i, a, b, c;
    string s = "";

    if (sol.size() >= (3*K)/2) return;
    if (!n && nr)
    {
        for (i = 0; i < M; i++)
        {
            a = E[i][0], b = E[i][1], c = E[i][2];
            if (G[a][b]&1 != (c+1)&1) return;
            s += !(G[a][b]&1) ? "A" : "R";
        }
        if (H[s]) return;
        sol.push_back(s); H[s] = true;
        return;
    }

    for (i = 0; i < N; i++)
    {
        if (G[n][i] == -1 || G[n][i] >= 2) continue;
        G[n][i]++; G[i][n]++;
        bkt(i, nr+1);
        G[n][i]--; G[i][n]--;
    }
}

int main(void)
{
    int i, t;

    freopen(FIN, "r", stdin);
    freopen(FOUT, "w", stdout);
    
    scanf("%d %d %d", &N, &M, &K);
    memset(type, -1, sizeof(type));
    memset(G, -1, sizeof(G));
    for (i = 0; i < M; i++)
    {
        scanf("%d %d %d", E[i], E[i]+1, E[i]+2);
        E[i][0]--; E[i][1]--;
        G[E[i][0]][E[i][1]] = G[E[i][1]][E[i][0]] = 0;
    }

    bkt(0, 0);

    sort(sol.begin(), sol.end());
    printf("%s\n", sol[K-1].c_str());
    
    return 0;
}
