#include <ctype.h>
#include <stdio.h>

#define FIN "peg.in"
#define FOUT "peg.out"

#define MAX_N 150000
#define MAX_L 400000

int n, c, T[MAX_N];

int back(int lev)
{
	int i;

	if (lev == c) return 1;
    for (i = 0; i < n; i++)
	{
	    if (i + 2 < n && T[i] && T[i + 1] && !T[i + 2])
		{
		    T[i] = T[i + 1] = 0, T[i + 2] = 1;
			if (back(lev + 1)) return 1;
			T[i] = T[i + 1] = 1, T[i + 2] = 0;
		}
	    if (i - 2 >= 0 && T[i] && T[i - 1] && !T[i - 2])
		{
		    T[i - 2] = 1, T[i - 1] = T[i] = 0;
			if (back(lev + 1)) return 1;
			T[i - 2] = 0, T[i - 1] = T[i] = 1;
		}
	}
	return 0;
}

int main(void)
{
	int tests;
	char line[MAX_L], *p;

	freopen(FIN, "r", stdin);
	freopen(FOUT, "w", stdout);

	scanf("%d\n", &tests);
	while (tests--)
	{
	    fgets(line, MAX_L, stdin), p = line;
		for (n = c = 0; isdigit(*p); p++, n++)
		{
		    T[n] = (*p) - '0';
			if (T[n]) c++;
		}
		c--;
		if (c) printf("%d\n", back(0));
		else printf("1\n");
	}

	return 0;
}
