#include <stdio.h>

#define MMAX 200
#define NMAX 200

FILE *fin,*fout;

int N,M,s[NMAX+1];
long long K;
struct muchie
{int c1,c2,tip;
 int conect;
}muc[MMAX+1];
struct Nod
{int v,adv;
 Nod *leg;
}*gr[NMAX+1];
int mat[NMAX+1][MMAX+1],rez[NMAX+1];
char config[MMAX+1];
int nsol;

long long put_doi(int nr)
{long long total;
 if (!nr) return 1;
 else if (nr==1) return 2;
 else {total=put_doi(nr/2);
       total=total*total;
       if (nr%2==1) total*=2;
       return total;
      }
}

int rez_sys(int sp)
{int i,j,k,last,aux,l,bol;
 for (i=sp+1,last=1;i<=M;++i)
     if (muc[i].conect&&muc[i].tip==0)
     {for (j=last;j<=N;++j)
         if (s[j]&&mat[j][i]==1)
            {if (j>last)
                {for (k=i;k<=M;++k)
                     {aux=mat[last][k];mat[last][k]=mat[j][k];
                      mat[j][k]=aux;
                     }
                 aux=rez[j];rez[j]=rez[last];rez[last]=aux;
                }
             for (k=j+1;k<=N;++k)
                 if (s[k]&&mat[k][i]==1)
                    {mat[k][i]=0;
                     for (l=i+1;l<=M;++l)
                         {aux=mat[k][l]-mat[last][l];
                          if (aux<0) aux+=2;
                          mat[k][l]=aux;
                         }
                     aux=rez[k]-rez[last];
                     if (aux<0) aux+=2;
                     rez[k]=aux;
                    }
             ++last;
             break;
            }
     }
 nsol=M-sp;
 for (i=sp+1;i<=M;++i)
    if (!muc[i].conect||muc[i].tip!=0) --nsol;
 for (i=1;i<=N;++i)
     if (s[i])
     {bol=1;
      for (j=sp+1;j<=M;++j)
         if (mat[i][j]==1) {--nsol;bol=0;break;}
      if (bol&&rez[i]) return 0;
     }
 return 1;
}

void add_edge(int x,int y,int advx)
{Nod *p;
 p=new Nod;p->v=y;p->adv=advx;p->leg=gr[x];gr[x]=p;
}
void dfs(int nod)
{Nod *p;
 s[nod]=1;
 for (p=gr[nod];p;p=p->leg)
     {muc[p->adv].conect=1;
      if (!s[p->v]) dfs(p->v);
     }
}

int main()
{int i,j,add,k;
 long long cK;
 fin=fopen("bcolor.in","r");
 fscanf(fin,"%d %d %lld",&N,&M,&K);
 for (i=1;i<=M;++i)
     {fscanf(fin,"%d %d %d",&muc[i].c1,&muc[i].c2,&muc[i].tip);
      add_edge(muc[i].c1,muc[i].c2,i);
      add_edge(muc[i].c2,muc[i].c1,i);
     }
 fclose(fin);
 dfs(1);
 for (i=1;i<=M;++i)
     {if (muc[i].tip==1||!muc[i].conect)
         config[i]='A';
      else if (muc[i].tip==2) config[i]='R';
      else {for (j=1;j<=N;++j) rez[j]=0;
            for (j=1;j<i;++j)
                {if (config[j]=='A') add=0;
                 else add=1;
                 rez[muc[j].c1]^=add;
                 rez[muc[j].c2]^=add;
                }
            for (j=1;j<=N;++j)
               for (k=i+1;k<=M;++k) mat[j][k]=0;
            for (j=i+1;j<=M;++j)
                if (muc[j].conect)
                {if (muc[j].tip==0)
                   {mat[muc[j].c1][j]=1;
                    mat[muc[j].c2][j]=1;
                   }
                 else if (muc[j].tip==2)
                     {add=1;
                      rez[muc[j].c1]^=add;
                      rez[muc[j].c2]^=add;
                     }
                }
            if (rez_sys(i))
              {cK=put_doi(nsol);
               if (cK>=K) {config[i]='A';}
               else {K-=cK;config[i]='R';}
              }
            else config[i]='R';
           }
     }
 fout=fopen("bcolor.out","w");
 for (i=1;i<=M;++i)
    fprintf(fout,"%c",config[i]);
 fclose(fout);
 return 0;
}
