#include <cstdio>
#include <cstdlib>
#include <vector>

using namespace std;

int i,j,n,m,k;

int G[256][256];

int S[256];
int tat[256];

vector<int> C[256];

void readdata(){
	FILE *f=fopen ("import.in","r");
	fscanf (f,"%d%d%d",&n,&m,&k);
	for (i=1;i<n;i++){
		int a,b;
		fscanf (f,"%d%d",&a,&b);
		C[a].push_back(b);
		C[b].push_back(a);
	}

	memset(G,1,sizeof(G));
	for (i=1;i<=n;i++)
		G[0][i]=0;

	for (i=1;i<=m;i++){
		int a,b,c,d;
		fscanf (f,"%d%d%d%d",&a,&b,&c,&d);
		if (d==0)
			G[b][a]=-c;	
		else
			G[a][b]=c-1;
	}
}

int P[256];

void df(int x){
	if (x>k&&tat[x]==1)
		P[x]=S[x];
	else
		if (x!=1)
		P[x]=S[x]-S[tat[x]];
	int i;
	for (i=0;i<C[x].size();i++)
		if (!tat[C[x][i]])
			tat[C[x][i]]=x,df(C[x][i]);
}

void bellmand(){
	S[0]=0;
	for (i=0;i<=n;i++)
		for (j=0;j<=n;j++)
			for (int p=0;p<=n;p++)
				if (S[p]>S[j]+G[j][p])
					S[p]=S[j]+G[j][p];

	for (i=0;i<=n;i++)
		for (j=0;j<=n;j++)
			if (S[j]>S[i]+G[i][j]) {
				printf ("No solution\n");
				exit(0);
			}
}

void solve(){
	bellmand();

	for (i=k+1;i<=n;i++)
		S[i]=-S[i];

	P[1]=S[1];
	tat[1]=-1;
	df(1);
}

void writedata(){
	FILE *f=fopen ("import.out","w");
	for (i=1;i<=n;i++)
		fprintf (f,"%d ",P[i]);
}

int main(){
	readdata();
	solve();
	writedata();

	return 0;
}