#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define MAXN 256
#define MAXEC 10000

int N, M, K;
int G[MAXN][MAXN], viz[MAXN], P[MAXN], tata[MAXN];
int ec[MAXEC][MAXN], sum[MAXN], type[MAXN];

void dfs_rad(int x)
{
    int i, v;
    for(i = 1; i <= G[x][0]; i++)
    {
        v = G[x][i];
        if(!viz[v])
            viz[v] = 1, tata[v] = x, dfs_rad(v);
    }
}

int main(void)
{
    int i, a, b, t, c, j, d, k;
    
    freopen("import.in", "rt", stdin);
    freopen("import.out", "wt", stdout);

    scanf("%d %d %d\n", &N, &M, &K);

    for(i = 1; i < N; i++)
    {
        scanf("%d %d\n", &a, &b);
        G[a][++G[a][0]] = b, G[b][++G[b][0]] = a;
    }

    viz[1] = 1, dfs_rad(1);
    
    if(M == 1)
    {
        scanf("%d %d %d %d\n", &a, &b, &c, &d);
        if(d == 0)
            printf("100000");
        else
            printf("-100000\n");
    }
    for(i = 1; i <= M; i++)
    {
        scanf("%d %d %d %d\n", &a, &b, &c, &d), sum[i] = c;
        type[i] = d;
        while(tata[a])
            ec[i][++ec[i][0]] = a, a = tata[a];
        while(tata[b])
            ec[i][++ec[i][0]] = b, b = tata[b];
        ec[i][0]--;
    }

    srand(time(0));
    
    for(i = 1; i <= N; i++)
        P[i] = rand() % 200001-100000;
    P[1] = 0;

    for(i = 1; i <= N; i++)
        printf("%d ", P[i]);

    return 0;
}



