#include <stdio.h>

FILE *f = fopen("perfect.in", "r");
FILE *g = fopen("perfect.out", "w");

long const kmax = 105;
long const nmax = 5001;

long rez[nmax];
long a[nmax] = {5, 1, 2, 3, 4 ,5}, b[nmax] = {6, 1, 2, 3, 4, 5 ,6 };
long nra = 12345, nrb = 123456;

char tip;
long n;
long t[kmax][nmax], u[nmax][kmax], v[nmax][kmax];

void citeste();
void aduna(long *a, long *b);
void inmcif(long *a, long cif);
void inmult(long *a, long *b);
void copi(long *a, long *b);//a = b
void scrie(long *a);
void zeros(long *a, long k);
void zerod(long *a, long k);

int main() {
	citeste();
	fclose(f);
	fclose(g);
	return 0;
}

void citeste() {
	long i;
	long long real;
	long temp[nmax];
	
/*	inmult(a, b); real = nra * nrb;
	aduna(a, b); real = nra + nrb;
	zeros(a, 4);
	zerod(a, 4);
	copi(a, b);
	inmcif(a, 9); real = nra * 9;
	scrie(rez);*/
	fscanf(f, "%c%ld", &tip, &n);
	switch(tip) {
		case 'A': {
			t[0][0] = 1;
			t[0][1] = 1;
			t[1][0] = 1;
			t[1][1] = 1;
			for(i=2; i<=n; i++) {
				aduna(t[i-1], t[i-2]);
				copi(t[i], rez);
			/*	inmult(t[i-1], t[i-2]);
				copi(temp, rez);
				inmcif(temp, 2);
				scrie(rez);
				copi(u[i-1], rez);*/
			}
			scrie(t[n]);
			break;
		}
		case 'B': {
			t[0][0] = 1;
			t[0][0] = 1;
			t[1][0] = 1;
			t[1][1] = 1;
			for(i=2; i<=n; i++) {
				aduna(t[i-1], t[i-2]);
				copi(t[i], rez);
			}
			inmult(t[n], t[n-1]);
			copi(temp, rez);
			inmcif(temp, 2);
			scrie(rez);
		}
		case 'C': {
			break;
		}
	}
}

void aduna(long *a, long *b) {
	long i, zec, sum;

	zec = 0;
	rez[0] = 0;
	if(a[0] < b[0]) zeros(a, b[0] - a[0]);
	if(a[0] > b[0]) zeros(b, a[0] - b[0]);
	rez[0] = a[0];
	for(i = rez[0]; i>=1; i--) {
		sum = a[i] + b[i] + zec;
		rez[i] = sum % 10;
		zec = sum / 10;
	}
	if(zec > 0) {
		zeros(rez, 1);
		rez[1] = zec;
	}
}

void inmcif(long *a, long cif) {
	long i, zec, sum;

	zec = 0;
	rez[0] = a[0];
	for(i = rez[0]; i >= 1; i--) {
		sum = a[i] * cif + zec;
		rez[i] = sum % 10;
		zec = sum / 10;
	}
	if(zec > 0) {
		zeros(rez, 1);
		rez[1] = zec;
	}
}

void inmult(long *a, long *b) {
	long i, suma[nmax], temp[nmax];

	rez[0] = 0;
	suma[0] = 0;
	for(i=b[0]; i>=1; i--) {
		inmcif(a, b[i]);
		copi(temp, rez);
		zerod(temp, b[0] - i);
		aduna(suma, temp);
		copi(suma, rez);
	}
	copi(rez, suma);
}

void copi(long *a, long *b) {//a = b
	long i;

	a[0] = b[0];
	for(i=1; i<=a[0]; i++) a[i] = b[i];
}

void scrie(long *a) {
	long i, pr;

	for(i=1; i<=a[0]; i++) if(a[i]!=0) {
		pr = i;
		break;
	}
	for(i=pr; i<a[0]; i++) fprintf(g, "%ld", a[i]);
	fprintf(g, "%ld\n", a[a[0]]);
}

void zeros(long *a, long k) {
	long i, b[nmax];
	
	b[0] = a[0] + k;
	for(i=1; i<=k; i++) b[i] = 0;
	for(i=1; i<=a[0]; i++) b[ i + k] = a[i];
	copi(a, b);
}

void zerod(long *a, long k) {
	long i;

	for(i=a[0]+1; i<=a[0] + k; i++) a[i] = 0;
	a[0] = a[0] + k;
}

