#include <stdio.h>
#include <string.h>

#define NRCF 10000

void read(void);
void plus(int *a, int *b, int *c);
void mult(int *a, int *b);

int N, A[NRCF], B[NRCF], C[NRCF], rez[NRCF], tmp[NRCF];
char c;

int main(void)
{
	int i;

	freopen("perfect.in", "r", stdin);
    freopen("perfect.out", "w", stdout);

    read();

    A[0] = 1, A[1] = 1;
    B[0] = 1, B[1] = 2;

    for (i = 3; i <= N; i++)
    {
		plus(A, B, C);
        memcpy(A, B, (B[0] + 1) * sizeof(int));
        memcpy(B, C, (C[0] + 1) * sizeof(int));
    }

    if (c == 'A')
    	memcpy(rez, B, (B[0] + 1) * sizeof(int));

	if (c == 'B')
    {
    	rez[0] = 1, rez[1] = 2;
        mult(rez, A);
        mult(rez, B);
    }

    for (i = rez[0]; i >= 1; i--)
    	printf("%d", rez[i]);

	printf("\n");

    return 0;
}

void read(void)
{
	scanf("%c %d", &c, &N);
}

void plus(int *a, int *b, int *c)
{
	int i, t = 0;

	while (a[0] < b[0]) a[++a[0]] = 0;
    while (b[0] < a[0]) b[++b[0]] = 0;

    c[0] = a[0];

    for (i = 1; i <= a[0]; i++)
    	c[i] = a[i] + b[i] + t, t = c[i] / 10, c[i] %= 10;

	if (t)
    	c[++c[0]] = t;

	while (!a[a[0]] && a[0] > 1) a[0]--;
    while (!b[b[0]] && b[0] > 1) b[0]--;
}

void mult(int *a, int *b)
{
	int i, j, t = 0;

    memset(tmp, 0, sizeof(tmp));

	tmp[0] = a[0] + b[0] - 1;

    for (i = 1; i <= a[0]; i++)
    	for (j = 1; j <= b[0]; j++)
        	tmp[i + j - 1] += a[i] * b[j];

	for (i = 1; i <= tmp[0]; i++)
    	tmp[i] += t, t = tmp[i] / 10, tmp[i] %= 10;

	while (t)
    	tmp[++tmp[0]] = t % 10, t /= 10;

	memcpy(a, tmp, (tmp[0] + 1) * sizeof(int));
}
