#include <stdio.h>

#define BAZA 10000

typedef struct Huge{
	int Cif;
	int Q[100];
};

char C;
int N;
//int SOLA[101];
//int SOLB[101];
Huge SOLA[101];
Huge SOLB[101];
Huge SOLC[101];

//int SOL;
Huge SOL;

void Initializare(Huge &A, int val){// mai mic decat baza
	A.Cif = 1;
	A.Q[0] = val;
	A.Q[1] = 0;
}

void Adunare(Huge &A, Huge B, Huge C){
	int a;
	for(a=0;a<=B.Cif || a<=C.Cif;a++){
		A.Q[a] = B.Q[a] + C.Q[a];
	}
	A.Q[a] = A.Q[a+1] = 0;
	for(a=0;a<=B.Cif || a<=C.Cif;a++){
		if (A.Q[a] >= BAZA){
 			A.Q[a] -= BAZA;
			A.Q[a+1]++;
		}
	}
	for(a--;A.Q[a];a++);
	A.Cif = a;
}

void Inmultire2(Huge &A, Huge B, Huge C){
	int a,b;
	for(a=0;a<=B.Cif+C.Cif;a++){
		A.Q[a] = 0;
	}
	for(a=0;a<=B.Cif;a++){
		for(b=0;b<=C.Cif;b++){
			A.Q[a+b] += B.Q[a] * C.Q[b];
			A.Q[a+b+1] += A.Q[a+b] / BAZA;
			if (A.Q[a+b+1] >= BAZA) A.Q[a+b+1] -= BAZA;
			A.Q[a+b] %= BAZA;
		}
	}
	for(a=0;A.Q[a];a++);
	A.Cif = a;
}

void Afisare(FILE *e, Huge &A){
	int a;
	fprintf(e, "%d", A.Q[A.Cif-1]);
	for(a=A.Cif-2;a>=0;a--){
		fprintf(e, "%04d", A.Q[a]);
	}
}

/*
void CalcA(void){
	int a;
	SOLA[0] = 1;
	SOLA[1] = 1;
	for(a=2;a<=N;a++){
		SOLA[a] = SOLA[a-1] + SOLA[a-2];
	}
	SOL = SOLA[N];
}//*/
//*
void CalcA(void){
	int a;
	Initializare(SOLA[0], 1);
	Initializare(SOLA[1], 1);
	for(a=2;a<=N;a++){
		Adunare(SOLA[a], SOLA[a-1], SOLA[a-2]);
	}
	SOL = SOLA[N];
}//*/

/*
void CalcB(void){
	int a;
	CalcA();
	for(a=1;a<=N;a++){
		SOLB[a] = 2 * SOLA[a] * SOLA[a-1];
	}
	SOL = SOLB[N];
}//*/
//*
void CalcB(void){
	int a;
	CalcA();
	for(a=1;a<=N;a++){
		//SOLB[a] = 2 * SOLA[a] * SOLA[a-1];
		Inmultire2(SOLB[a], SOLA[a], SOLA[a-1]);
		Adunare(SOLB[a], SOLB[a], SOLB[a]);
	}
	SOL = SOLB[N];
}//*/

void CalcC(void){
	int a;
	Huge Patru;
	Initializare(SOLC[1], 2);
	Initializare(Patru, 4);
	for(a=2;a<=N;a++){
		Inmultire2(SOLC[a], SOLC[a-1], Patru);
	}
	SOL = SOLC[N];
}

int main(void){
	int a;
	FILE *e,*ee;
	e = fopen("perfect.in","r");
		fscanf(e, "%c %d", &C, &N);
	fclose(e);
	if (C == 'A') CalcA();
	if (C == 'B') CalcB();
	if (C == 'C') CalcC();
	ee = fopen("perfect.out","w");
		//fprintf(ee, "%d\n", SOL);
		Afisare(ee, SOL);
		fprintf(ee, "\n");
	fclose(ee);
	return 0;
}

