#include <stdio.h>

#define NMAX 100

FILE *fin,*fout;

const int baza=10000;
int N;
typedef int numar[501];
numar aux,F1,F2,F3,csol,aux2,aux3;
numar fib[NMAX+1];

void aduna(numar s,numar a,numar b)
{int i,t,la=a[0],lb=b[0];
 for (i=1,t=0;i<=la&&i<=lb;++i)
     {s[i]=(a[i]+b[i]+t)%baza;
      t=(a[i]+b[i]+t)/baza;
     }
 for (;i<=la;++i)
     {s[i]=(a[i]+t)%baza;
      t=(a[i]+t)/baza;
     }
 for (;i<=lb;++i)
     {s[i]=(b[i]+t)%baza;
      t=(b[i]+t)/baza;
     }
 if (t) {s[i]=t;++i;}
 s[0]=i-1;
}
void copiaza(numar a,numar b)
{int i;
 a[0]=b[0];
 for (i=1;i<=b[0];++i)
     a[i]=b[i];
}
void inmult2(numar s,numar a)
{int i,t,la=a[0];
 for (i=1,t=0;i<=la;++i)
     {s[i]=(a[i]*2+t)%baza;
      t=(a[i]*2+t)/baza;
     }
 if (t) {s[i]=t;++i;}
 s[0]=i-1;
}
void inmult(numar s,numar a,numar b)
{int i,j,la=a[0],lb=b[0],t,cif;
 numar pr,s_aux;
 s[0]=1;s[1]=0;
 for (j=1;j<=lb;++j)
     {cif=b[j];
      for (i=1,t=0;i<=la;++i)
          {pr[i]=(a[i]*cif+t)%baza;
           t=(a[i]*cif+t)/baza;
          }
      if (t) {pr[i]=t;++i;}
      pr[0]=i-1;
      for (i=1;i<j;++i) s_aux[i]=s[i];
      for (i=j,t=0;i<=s[0];++i)
          {s_aux[i]=(s[i]+pr[i-j+1]+t)%baza;
           t=(s[i]+pr[i-j+1]+t)/baza;
          }
      for (;i-j+1<=pr[0];++i)
          {s_aux[i]=(pr[i-j+1]+t)%baza;
           t=(pr[i-j+1]+t)/baza;
          }
      if (t) {s_aux[i]=t;++i;}
      s_aux[0]=i-1;
      copiaza(s,s_aux);
     }
}
void put_doi(int val)
{if (val==1) {csol[0]=1;csol[1]=2;}
 else
     {put_doi(val/2);
      inmult(aux,csol,csol);
      if (val%2==1)
         {inmult2(csol,aux);
         }
      else copiaza(csol,aux);
     }
}
int get_lung(int val)
{int i;
 for (i=0;val;val/=10) ++i;
 return i;
}
void afis(numar sol)
{int i,l,j;
 for (i=sol[0];i>=1;--i)
     {l=get_lung(sol[i]);
      if (!l) ++l;
      if (i!=sol[0]) for (j=1;j<=4-l;++j) fprintf(fout,"0");
      fprintf(fout,"%d",sol[i]);
     }
 fprintf(fout,"\n");
}

int main()
{int i;
 char car;
 fin=fopen("perfect.in","r");
 fscanf(fin,"%c %d",&car,&N);
 fclose(fin);
 fout=fopen("perfect.out","w");
 switch (car)
        {case 'A':if (N==1)
                     fprintf(fout,"1\n");
                  else
                     {F1[0]=F2[0]=1;F1[1]=F2[1]=1;
                      for (i=2;i<=N;++i)
                          {aduna(F3,F1,F2);
                           copiaza(F1,F2);
                           copiaza(F2,F3);
                          }
                      afis(F3);
                     }
                  break;
         case 'B':if (N==1)
                    fprintf(fout,"2\n");
                  else if (N==2)
                    fprintf(fout,"4\n");
                  else
                      {fib[0][0]=fib[1][0]=1;fib[0][1]=fib[1][1]=1;
                       for (i=2;i<=N;++i)
                           aduna(fib[i],fib[i-1],fib[i-2]);
                       inmult(csol,fib[N-1],fib[N-1]);
                       inmult2(aux,csol);
                       inmult(aux2,fib[N-2],fib[N-1]);
                       inmult2(aux3,aux2);
                       aduna(csol,aux,aux3);
                       afis(csol);
                      }
                  break;
         case 'C':if (N==1) fprintf(fout,"2\n");
                  else
                      {N=(N*(N+1))/2;
                       put_doi(N);
                       afis(csol);
                      }
        }
 fclose(fout);
 return 0;
}
