#include<stdio.h>
#define MOD 10000
struct NUMAR{int n,x[10000];};
FILE *fin,*fout;

inline int min(int x, int y)
  {return (x<y)?x:y;}

NUMAR suma(NUMAR a, NUMAR b)
  {NUMAR s;
   int i=0,in_minte=0,minim;
   minim=min(a.n,b.n);
   while(i<minim)
       {s.x[i]=a.x[i]+b.x[i]+in_minte;
        in_minte=s.x[i]/MOD;
        s.x[i]%=MOD;
        i++;}
   while(i<a.n)
       {s.x[i]=a.x[i]+in_minte;
        in_minte=s.x[i]/MOD;
        s.x[i]%=MOD;
        i++;}
   while(i<b.n)
       {s.x[i]=b.x[i]+in_minte;
        in_minte=s.x[i]/MOD;
        s.x[i]%=MOD;
        i++;}
   while(in_minte)
       {s.x[i]=in_minte%MOD;
        in_minte/=MOD;
        i++;}
   s.n=i;
   return s;}

NUMAR produs_scalar(NUMAR a, int scalar)
  {NUMAR p;
   int i=0,in_minte=0;
   while(i<a.n)
       {p.x[i]=a.x[i]*scalar+in_minte;
        in_minte=p.x[i]/MOD;
        p.x[i]%=MOD;
        i++;}
   while(in_minte)
       {p.x[i]=in_minte%MOD;
        in_minte/=MOD;
        i++;}
   p.n=i;
   return p;}

NUMAR adauga_poz(int poz, NUMAR a, NUMAR b, NUMAR s)
  {int i=0,in_minte=0,minim;
   while(i<poz)
        {s.x[i]=a.x[i];
         i++;}
   while(a.n-1<poz)
        a.x[a.n++]=0;
   minim=min(a.n-poz,b.n);
   i=0;
   while(i<minim)
       {s.x[i+poz]=a.x[i+poz]+b.x[i]+in_minte;
        in_minte=s.x[i+poz]/MOD;
        s.x[i+poz]%=MOD;
        i++;}
   while(i<b.n)
       {s.x[i+poz]=b.x[i]+in_minte;
        in_minte=s.x[i+poz]/MOD;
        s.x[i+poz]%=MOD;
        i++;}
   while(i<a.n-poz)
       {s.x[i+poz]=a.x[i+poz]+in_minte;
        in_minte=s.x[i+poz]/MOD;
        s.x[i+poz]%=MOD;
        i++;}
   while(in_minte)
       {s.x[i+poz]=in_minte%MOD;
        in_minte/=MOD;
        i++;}
   s.n=i+poz;
   return s;}

NUMAR produs(NUMAR a, NUMAR b)
  {NUMAR p,t;
   p.n=1;
   p.x[0]=0;
   for(int i=0;i<a.n;i++)
      p=adauga_poz(i,p,produs_scalar(b,a.x[i]),t);
   return p;}

NUMAR A(int n)
  {int i;
   NUMAR f0,f1,f2;
   f0.n=f1.n=f2.n=1;
   f0.x[0]=1;
   if(n==0 || n==1)
     return f0;
   f1.x[0]=2;
   if(n==2)
     return f1;
   for(i=2;i<n;i++)
      {f2=suma(f0,f1);
       f0=f1;
       f1=f2;}
   return f2;}

void scrie(NUMAR a)
  {fprintf(fout,"%d",a.x[a.n-1]);
   for(int i=a.n-2;i>=0;i--)
     {int _10=1000;
      for(int j=0;j<4;j++)
         {fprintf(fout,"%d",a.x[i]/_10);
          a.x[i]%=_10;
          _10/=10;}}
   fprintf(fout,"\n");}

NUMAR B(int n)
  {return produs_scalar(produs(A(n),A(n-1)),2);}


int main()
{
char op;
int n;
fin=fopen("perfect.in","r");
fout=fopen("perfect.out","w");
fscanf(fin,"%c %d",&op,&n);
switch(op)
  {case 'A': scrie(A(n));
             break;
   case 'B': scrie(B(n));
             break;
   case 'C': fprintf(fout,"2\n");
             break;}
fclose(fin);fclose(fout);
return 0;
}
