#include <stdio.h>

#include <algorithm>
using namespace std;

#define NMAX 30100
#define KMAX 1100
#define INF 666666666

int nbaze[NMAX], nacid[NMAX], cacid[NMAX], cbaza[NMAX], sacid[NMAX], sbaza[NMAX], C[NMAX][2], S[KMAX];
int i, j, k, x, M, N, NN, B, P, K, vmin, extra, ok, lastA, lastB, round;

int df(int p, int selbaza)
{
	int res, j;

	if (sacid[C[p][0]] > 0 && (sacid[C[p][0]] <= round - 2 || sacid[C[p][0]] == round) )
	{
		if (selbaza)
			return 0;

		return 1;
	}

	if (sbaza[C[p][1]] > 0 && (sbaza[C[p][1]] <= round - 2 || sbaza[C[p][1]] == round))
	{
		if (!selbaza)
			return 0;

		return 1;
	}

	sacid[C[p][0]] = sbaza[C[p][1]] = 0;

	if (selbaza)
	{
		sbaza[C[p][1]] = round;
		res = 1;

		for (j = 1; j <= P && res; j++)
			if (j != p && nbaze[C[p][0]] >= C[j][1])
				res &= df(j, 1);
	
		if (!res)
			sbaza[C[p][1]] = 0;

		return res;
	}
	else
	{
		sacid[C[p][0]] = round;
		res = 1;

		for (j = 1; j <= P && res; j++)
			if (j != p && nacid[C[p][1]] <= C[j][0])
				res &= df(j, 0);

		if (!res)
			sacid[C[p][0]] = 0;

		return res;
	}
}

int main()
{
	int T;

	freopen("ab.in", "r", stdin);
	freopen("ab.out", "w", stdout);

	scanf("%d", &T);
	while (T--)
	{
		scanf("%d %d %d", &M, &N, &K);
		for (i = 1; i <= K; i++)
			scanf("%d", &S[i]);

		sort(&S[1], &S[K + 1]);
		
		NN = N;
		P = nbaze[0] = 0;
		for (i = 1; i <= M; i++)
		{
			scanf("%d", &B);
			nbaze[i] = nbaze[i - 1] + B;
		
			while (B--)
			{
				P++;
				nacid[P] = i;
			}
		}

		// scapa de bazele care nu reactioneaza cu nici un acid
		extra = (N - P) * S[1];
		N = P;

		fprintf(stderr, "*\n");
		vmin = ok = 0;

		for (i = 1; i <= M; i++)
			cacid[i] = 0;

		for (i = 1; i <= N; i++)
			cbaza[i] = 0;


		// iterative MIS

		x = 0;
		while (!ok)
		{
			x++;

			if (x > K)
			{
				vmin = INF;
				break;
			}

			// cuplaj maxim

			for (i = 1; i <= M; i++)
				sacid[i] = 0;

			for (i = 1; i <= N; i++)
				sbaza[i] = 0;

			P = lastB = 0;
			for (i = 1; i <= M; i++)
				if (!cacid[i])
				{
					k = lastB + 1;
					while (nbaze[i] >= k && cbaza[k]) k++;

					if (nbaze[i] >= k)
					{
						lastB = k;
						P++;
						C[P][0] = i;
						C[P][1] = lastB;
					}
					else
					{
						if (P > 0)
							sbaza[C[P][1]] = 1;

						lastB = k - 1;
					}
				}

			if (P > 0)
			{
				if (N > C[P][1])
				{
					for (i = P; i >= 1; i--)
						if (nacid[C[P][1] + 1] <= C[i][0])
							sacid[C[i][0]] = 1;
				}

				round = 0;
				for (i = 1; i <= P; i++)
					if (!sacid[C[i][0]] && !sbaza[C[i][1]])
					{
						//fprintf(stderr, "starting df\n");

						round++;
						if (!df(i, 0))
						{
							round++;
							df(i, 1);
						}
						else
							round++;

						//fprintf(stderr, "done df\n");
					}
			}
			else
				ok = 1;

			// ce acizi sunt eliminati
			k = 0;

			for (i = 1; i <= M; i++)
				if (!cacid[i] && !sacid[i])
				{
					cacid[i] = x;
					vmin += S[x];
					k++;
				}

			fprintf(stderr, "sunt colorati %d acizi cu culoarea %d\n", k, x);

			// ce baze sunt eliminate
			k = 0;

			for (i = 1; i <= N; i++)
				if (!cbaza[i] && !sbaza[i])
				{
					cbaza[i] = x;
					vmin += S[x];
					k++;
				}

			fprintf(stderr, "sunt colorate %d baze cu culoarea %d\n", k, x);

			while (N > 0 && cbaza[N])
				N--;
		}

		if (S[1] * M + S[2] * NN < vmin)
			vmin = S[1] * M + S[2] * NN;

		if (S[2] * M + S[1] * NN < vmin)
			vmin = S[2] * M + S[1] * NN;

		printf("%d\n", vmin + extra);
	}

	return 0;
}