#include <stdio.h>
#include <string.h>

#include <algorithm>
#include <vector>

using namespace std;

#define NMAX 1111
#define PMAX 30
#define INF 666666666

vector<pair<int, int> > v[NMAX];
int dmin[2][NMAX][PMAX][2], viz[NMAX];
int N, P;

void df(int n)
{
    int i, x, y, f, l, pn, pf, en, ef, nf = 0, a ,c;
    
    viz[n] = 1;
    
    dmin[0][n][0][0] = dmin[0][n][0][1] = dmin[1][n][0][0] = dmin[1][n][0][1] = 0;
    
    for (x = 1; x <= P; x++)
	for (y = 0; y < 2; y++)
    	    dmin[y][n][x][0] = dmin[y][n][x][1] = INF;
	
    c = 0;
    for (i = 0; i < v[n].size(); i++)
    {
	f = v[n][i].first;
	l = v[n][i].second;
	
	if (!viz[f])
	{
	    nf++;
	    df(f);
	
	    a = c;
	    c = 1 - c;
	        
	    dmin[c][n][0][0] = dmin[c][n][0][1] = INF;
	    
	    for (pn = 1; pn <= P; pn++)
	    {
		dmin[c][n][pn][0] = dmin[c][n][pn][1] = INF;
		
		for (pf = 1; pf <= pn; pf++)
		{
		    // calculeaza dmin[c][n][pn][0]
		    if (dmin[a][n][pn - pf][0] + l * pf + dmin[0][f][pf][0] < dmin[c][n][pn][0])
			dmin[c][n][pn][0] = dmin[a][n][pn - pf][0] + l * pf + dmin[0][f][pf][0];
		    
    		    if (dmin[a][n][pn - pf + 1][1] + l * pf + dmin[0][f][pf][0] < dmin[c][n][pn][0])
			dmin[c][n][pn][0] = dmin[a][n][pn - pf + 1][1] + l * pf + dmin[0][f][pf][0];

		    if (dmin[a][n][pn - pf + 1][0] + l * (pf + 1) + dmin[0][f][pf][1] < dmin[c][n][pn][0])
			dmin[c][n][pn][0] = dmin[a][n][pn - pf + 1][0] + l * (pf + 1) + dmin[0][f][pf][1];
		    
		    // calculeaza dmin[c][n][pn][1]
		    if (dmin[a][n][pn - pf][0] + l * (pf + 1) + dmin[0][f][pf][1] < dmin[c][n][pn][1])
			dmin[c][n][pn][1] = dmin[a][n][pn - pf][0] + l * (pf + 1) + dmin[0][f][pf][1];   
		
		    if (dmin[a][n][pn - pf + 1][1] + l * (pf + 1) + dmin[0][f][pf][1] < dmin[c][n][pn][1])
			dmin[c][n][pn][1] = dmin[a][n][pn - pf + 1][1] + l * (pf + 1) + dmin[0][f][pf][1];
		}
	    }    
	}
    }

    for (pn = 0; pn <= P; pn++)
	for (y = 0; y < 2; y++)
    	    dmin[1 - c][n][pn][y] = dmin[c][n][pn][y];

    if (nf == 0)
	dmin[0][n][1][0] = dmin[0][n][1][1] = dmin[1][n][1][0] = dmin[1][n][1][1] = 0;

    dmin[0][n][0][0] = dmin[0][n][0][1] = dmin[1][n][0][0] = dmin[1][n][0][1] = INF;

    /*
    fprintf(stderr, "nodul %d  (%d fii)\n", n, nf);
    
    for (pn = 1; pn <= P; pn++)
	for (x = 0; x < 2; x++)
	    fprintf(stderr, "%d camioane ; %d se intorc -> dist = %d\n", pn, x, dmin[c][n][pn][x]);
    
    fprintf(stderr, "\n");
    */
}

int main()
{
    int i, j, k, l, pok, dok;

    freopen("camion.in", "r", stdin);
    
    scanf("%d %d", &N, &P);

    for (k = 1; k < N; k++)
    {
	scanf("%d %d %d", &i, &j, &l);
	v[i].push_back(make_pair(j, l));
	v[j].push_back(make_pair(i, l));	
    }

    memset(viz, 0, sizeof(viz));
    df(1);    

    freopen("camion.out", "w", stdout);

    pok = 0; dok = INF;
    
    for (i = 1; i <= P; i++)
	for (j = 0; j < 2; j++)
	{
	    //fprintf(stderr, "%d camioane ; %d se intorc -> dist = %d\n", i, j, dmin[0][1][i][j]);
	    
	    if (dmin[0][1][i][j] < dok)
	    {
		dok = dmin[0][1][i][j];
		pok = i;
	    }
	}

    printf("%d\n", dok);

    return 0;
}
