#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define NMAX 260

int A[NMAX][NMAX], w[NMAX], used[NMAX], sol[NMAX];
int i, j, k, N, M, oksol, concsol, csol, points, sum;

void eror(int points, char *msg)
{
	printf("%d %s\n", points, msg);
	exit(0);
}

int main()
{
	freopen("soc.in", "r", stdin);

	scanf("%d %d", &N, &M);

	for (i = 1; i <= N; i++)
		scanf("%d", &w[i]);

	//memset(A, 0, sizeof(A));

	while (M--)
	{
		scanf("%d %d", &i, &j);
		A[i][j] = A[j][i] = 1;
	}

	freopen("soc.ok", "r", stdin);
	scanf("%d", &oksol);

	freopen("soc.out", "r", stdin);

	points = 0;

	if (scanf("%d", &concsol) != 1)
		eror(0,"format incorect pt fisierul de iesire sau fisier de iesire gol");

	if (concsol > oksol)
	   eror(0,"capitalul societatii este prea mare :(");
	if (concsol < oksol)
	eror(0,"capitalul societatii este prea mic :(");
	if (scanf("%d", &csol) != 1)
		eror(3,"nu ati afisat si actionarii societatii sau i-ati afisat intr-un format gresit");

	if (csol < 0 || csol > N)
		eror(3,"valoare incorecta pentru numarul de actionari");

	memset(used, 0, sizeof(used));

	for (i = 1; i <= csol; i++)
	{
		if (scanf("%d", &sol[i]) != 1)
			eror(3,"nu ati afisat solutia completa sau ati afisat-o intr-un format incorect");

		if (sol[i] < 1 || sol[i] > N)
			eror(3,"ati afisat un actionar inexistent");

		used[sol[i]] = 1;
	}

	sum = 0;
	for (i = 1; i <= N; i++)
		if (used[i])
			sum += w[i];

	if (sum != concsol)
		eror(3,"actionarii afisati nu au capitalul specificat");

	if (concsol > oksol)
	   eror(1000,"!!!");

	eror(5, "ok");
	return 0;
}
