#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include <algorithm>
#include <vector>

using namespace std;

#define NMAX 260
#define NPERM 1000

int A[NMAX][NMAX], sol[NMAX], m[NMAX], p[NMAX], used[NMAX], w[NMAX];
vector<pair<int, int> > v;
int i, j, k, N, M, cnt, csol,sum, maxsum;

void random_permutations()
{
	int pe;

	srand(time(NULL));

	for (pe = 1; pe <= NPERM; pe++)
	{
		if (pe == 1)
		{
			for (i = 1; i <= N; i++)
				p[i] = v[N - i].second;
		}
		else
		if (pe == 2)
		{
			for (i = 1; i <= N; i++)
				p[i] = v[i - 1].second;
		}
		else
		{
			// generate random permutation

			for (i = 1; i <= N; i++)
				used[i] = 0;

			for (i = 1; i <= N; i++)
			{
				do
				{
					j = 1 + rand() % N;
				}
				while (used[j]);

				p[i] = j;
				used[j] = 1;
			}
		}

		// compute MIS in the order given by the permutation

		sum = w[p[1]];
		m[cnt = 1] = p[1];

		for (i = 2; i <= N; i++)
		{
			k = 1;
			for (j = 1; k && j <= cnt; j++)
				if (A[m[j]][p[i]])
					k = 0;

			if (k)
			{
				m[++cnt] = p[i];
				sum += w[p[i]];
			}
		}

		if (sum > maxsum)
		{
			maxsum = sum;
			csol = cnt;

			for (i = 1; i <= csol; i++)
				sol[i] = m[i];
		}

		if (pe <= 2)
			fprintf(stderr, "pe = %d ; sum = %d\n", pe, sum);
	}

	fprintf(stderr, "random permutations: %d\n", maxsum);
}

int main()
{
	freopen("soc2.in", "r", stdin);

	scanf("%d %d", &N, &M);

	v.clear();
	for (i = 1; i <= N; i++)
	{
		scanf("%d", &k);
		w[i] = k;
		v.push_back(make_pair(k, i));
	}

	memset(A, 0, sizeof(A));

	while (M--)
	{
		scanf("%d %d", &i, &j);
		A[i][j] = A[j][i] = 1;
	}

	sort(v.begin(), v.end());

	maxsum = csol = 0;

	random_permutations();

	freopen("soc2.out", "w", stdout);

	printf("%d\n%d\n", maxsum, csol);

	for (i = 1; i <= csol; i++)
		printf("%d ", sol[i]);
	printf("\n");

	return 0;
}
