{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

Program _soc_;

const filein='soc2.in';
      fileout='soc2.out';
      MAXN=256;
      maxpdeg=100;

type plist=^list;
     list=record
            vec:longint;
            urm:plist;
          end;

var sol,sact,perm,indepset,ncol,lstset:array[1..MAXN] of longint;
    asoc,deg,lst,lst2,marc,dego,nin,tata:array[1..MAXN] of longint;
    used:array[1..MAXN] of boolean;
    a:array[1..MAXN,1..MAXN] of boolean;
    e:array[1..MAXN] of longint;
    max,min,sum,act,i,j,k,m,n,p,nset,v,nv,ncomp,nedge,ninset,maxset,maxiter:longint;
    aux:plist;
    ok,oki:boolean;

procedure print;
begin
assign(output,fileout);
rewrite(output);

min:=0;
for i:=1 to n do
  if (sol[i]=1) then
    min:=min+e[i];
write(min,#13,#10);

min:=0;
for i:=1 to n do
  if (sol[i]=1) then
    min:=min+1;
write(min,#13,#10);

for i:=1 to n do
  if (sol[i]=1) then
    write(i,' ');
write(#13,#10);

close(output);
halt(0);
end;

procedure mindegfirst(n:longint);
var kk:longint;
begin
randomize;
for kk:=1 to maxpdeg do
  begin
    fillchar(used,sizeof(used),false);
    for i:=1 to n do
      begin
        repeat
          j:=random(n)+1;
        until (not used[j]);

        perm[i]:=j;
        used[j]:=true;
      end;

    fillchar(dego,sizeof(dego),0);
    fillchar(asoc,sizeof(asoc),0);

    for i:=1 to n do
      begin
        m:=n+1;
        k:=0;
        p:=-1;

        for j:=1 to n do
          if (asoc[lst[perm[j]]]=0) and
             ((deg[lst[perm[j]]]<m) or
              ((deg[lst[perm[j]]]=m) and (e[lst[perm[j]]]>p))
             )
              then
            begin
              k:=lst[perm[j]];
              m:=deg[lst[perm[j]]];
              p:=e[lst[perm[j]]];
            end;

        asoc[k]:=1;
        dego[i]:=k;
      end;

    sum:=0;
    fillchar(sact,sizeof(sact),0);

    for i:=1 to n do
      begin
        ok:=true;
        for j:=1 to n do
          if (a[dego[i],lst[j]]) and (sact[lst[j]]>0) then
            begin
              ok:=false;
              break;
            end;

        if (ok) then
          begin
            sact[dego[i]]:=1;
            sum:=sum+e[dego[i]];
          end;
      end;

    if (sum>min) then
      begin
        min:=sum;
        for i:=1 to n do
          sol[dego[i]]:=sact[dego[i]];
      end;
  end;
end;

procedure maxdeglast(n:longint);
var kk:longint;
begin
randomize;
for kk:=1 to maxpdeg do
  begin
    fillchar(used,sizeof(used),false);
    for i:=1 to n do
      begin
        repeat
          j:=random(n)+1;
        until (not used[j]);

        perm[i]:=j;
        used[j]:=true;
      end;

    fillchar(dego,sizeof(dego),0);
    fillchar(asoc,sizeof(asoc),0);

    for i:=n downto 1 do
      begin
        m:=-1;
        k:=0;
        p:=-1;

        for j:=1 to n do
          if (asoc[lst[perm[j]]]=0) and
             ((deg[lst[perm[j]]]>m) or
              ((deg[lst[perm[j]]]=m) and (e[lst[perm[j]]]>p))
             )
          then
            begin
              k:=lst[perm[j]];
              m:=deg[lst[perm[j]]];
              p:=e[lst[perm[j]]];
            end;

        asoc[k]:=1;
        dego[i]:=k;
      end;

    sum:=0;
    fillchar(sact,sizeof(sact),0);

    for i:=1 to n do
      begin
        ok:=true;

        for j:=1 to n do
          if (a[dego[i],lst[j]]) and (sact[lst[j]]>0) then
            begin
              ok:=false;
              break;
            end;

        if (ok) then
          begin
            sact[dego[i]]:=1;
            sum:=sum+e[dego[i]];
          end;
      end;

    if (sum>=min) then
      begin
        min:=sum;
        for i:=1 to n do
          sol[dego[i]]:=sact[dego[i]];
      end;
  end;
end;

procedure df(nod:longint);
var aux:plist;
    i:longint;
begin
marc[nod]:=ncomp;
for i:=1 to n do
  if (a[nod,i]) and (marc[i]=0) then
    df(i);
end;

begin
assign(input,filein);
reset(input);
read(n,m);

for i:=1 to n do
  read(e[i]);

fillchar(a,sizeof(a),false);
fillchar(deg,sizeof(deg),0);

for k:=1 to m do
  begin
    read(i,j);
    a[i,j]:=true;
    a[j,i]:=true;
  end;
close(input);

for i:=1 to n-1 do
  for j:=i+1 to n do
    if (a[i,j]) then
      begin
        inc(deg[i]);
        inc(deg[j]);
      end;

fillchar(sol,sizeof(sol),0);
fillchar(marc,sizeof(marc),0);
ncomp:=0;
max:=0;

for v:=1 to n do
  if (marc[v]=0) then
    begin
      inc(ncomp);
      nedge:=0;
      df(v);

      nv:=0;
      for i:=1 to n do
        if (marc[i]=ncomp) then
          begin
            inc(nv);
            lst[nv]:=i;
            lst2[nv]:=i;
          end;

      min:=0;
      mindegfirst(nv);
      maxdeglast(nv);
    end;

print;
end.